#!/bin/bash

#################################################################
# Name   : send_tcusE_NO.sh 
# Purpose: This shell is to add nwstg header to TCUS files and 
#          NOT send the product file to the distribution server. 
#          This scripts is called by GEIMAGER macro.  
# Input:
#     East: TCUS62
# Output:
#     T_TCUS62_C_KNES_20120623082711_GOESE_IMAGERASOS.txt 
#
# current time in format of "YYYYMMDDHHMMSS"
# Updated: 05/09/2013 by T. Nguyen/SSAI for VM-ware CCR#2126
# Updated: 01/17/2014 by T. Nguyen/SSAI for VM-ware CCR#2126
#################################################################

SCRIPTDIR=$( dirname $0 )
# call env setup file
. $HOME/iasos/scripts/iasos_env.sh

export tstrb=`date +%H%M%S`

script_name=`basename $0`
echo $script_name


hour=`date +%j%H`
echo "-------------------------------------------------------" >> $iasos_log/ftplog
echo $hour >> $iasos_log/ftplog

echo "#########current time is $time1" >> $iasos_log/ftplog

calcdate=`date +%Y%m%d.%H%M%S`
calcdat2=`date +%Y%m%d%H%M%S`
mstm=`date +%Y%m%d%H%M%S`
YYGGgg=`date +%d%H%M`

infileE=$iasos_data/TCUS62

#---- Perl script puts a /r/r/n at the end of each line in TCUS62 and TCUS54
$iasos_scripts/nwshead.pl $infileE

#--- Prepared the TCUS62 header
msgsz=`wc -c $iasos_log/newfile.txt | awk '{printf "%10.10d", $1}'`        # option 2
echo "newfile.txt size = "$msgsz >> $iasos_log/ftplog
sed '1,1d' $iasos_log/newfile.txt > $iasos_log/TCUSE
headline1=****$msgsz****            # option 2
headline2='TCUS62 KNES '$YYGGgg
echo "TCUS62 KNES "$YYGGgg >> $iasos_log/ftplog
outfile1='T_TCUS62_C_KNES_'$mstm'_GOESE_IMAGERASOS.txt'
echo -e $headline1"\n"$headline2"\r\r" > $outfile1
cat     $iasos_log/TCUSE   >> $outfile1
outsiz=`wc -c $outfile1 | awk '{printf "%6.6d", $1}'`
echo "T_TCUS62_C_KNES SIZE = "$outsiz >> $iasos_log/ftplog

#Copy the Imager ASOS to SFS   # T.Nguyen 07/10/2013
#cp $outfile1 $SFS_iasos_prod_dir

# Save log files by julian day and hourly
cp $iasos_log/GEOUT.LOG $iasos_log/GEOUT.LOG$hour

## archive files 
mv $iasos_data/T_TCUS*_C_KNES* $iasos_archive
mv $iasos_data/IMHOURE* $iasos_archive
mv $iasos_data/TCUS* $iasos_archive
mv $iasos_data/iadaily*.dat $iasos_archive
mv $iasos_data/lastrun*.day $iasos_archive
mv $iasos_data/MODTEMP $iasos_archive
mv $iasos_data/MODLIST $iasos_archive
mv $iasos_data/XXSJN8 $iasos_archive
mv $iasos_data/NameOflog.txt $iasos_archive
#mv $iasos_data/ImagerASOSE.log $iasos_archive
#mv $iasos_data/ASOSTATS $iasos_archive
