C ----------------------------------------------------------
C [ FUNCTION TO CONVERT FROM GVAR 4-BYTE REAL VALUES       [
C [ FORMATTED FOR THE GOULD/SEL COMPUTER INTO IBM REAL     [
C [ VALUES.                                                [
C [ ALL FLOATING POINT NUMBERS USED IN GVAR ARE 32 BITS IN [
C [ LENGTH, TRANSPORT VIA FOUR SEQUENTIAL 8-BIT WORDS.     [
C [ THIS FORMAT EMPLOYS A SIGN BIT, A 7-BIT EXPONENT, AND  [
C [ A 24 BIT FRACTIONAL MANTISSA DEFINED AS FOLLOWS:       [
C [                                                        [
C [ WORD     1           2          3          4           [
C [ BITS  1      8   1      8   1      8   1      8        [
C [       --------   --------   --------   --------        [
C [       SEEEEEEE   MMMMMMMM   MMMMMMMM   MMMMMMMM        [
C [                 MSB --- 24 BIT MANTISSA --- LSB        [
C [                                                        [
C [ FOR FURTHER INFORMATION CONSULT PP. 170-171 IN GVAR    [
C [ TRANSMISSION MANUAL 'OPERATIONS GROUND EQUIPMENT INTER-[
C [ FACE SPECIFICATION' DRL 504-02-1                       [
C [                                                        [
C [ RECEIVES: INTEGER*4 VALUE - 4-BYTE INTEGER VALUE HOLD- [
C [                             ING VALUE TO BE CONVERTED  [
C [ RETURNS:  REAL FRMT - FLOATING POINT VALUE             [
C ----------------------------------------------------------
       REAL FUNCTION FRMT(VALUE)

       INTEGER CONVRT, VALUE, TEMP
       INTEGER IEOR
       REAL             MEH

       EQUIVALENCE (MEH,TEMP)
       DATA CONVRT / Z'7FFFFFFF' /
       TEMP = VALUE
       IF (TEMP .LT. 0) TEMP = IEOR(TEMP, CONVRT) + 1

       CALL SWBYT4(MEH, 1)
       CALL FLTCON(MEH, 1)

       FRMT = MEH

       RETURN
       END
