      SUBROUTINE GIMDATX_IM(IMLIN,IMELE,GDAT)
c
c 04 Oct 01  JPN  repaired a bug I introduced when I changed the IUCH array to 
c                 (NC*2,2); it is now (NC,2) again...
c 29 Sep 01  JPN  now check for error return from GOESPFCO call (didn't before--
c                 a bug)
c 28 Sep 01  JPN  increased NWPL from 15000 to 50000 (will handle up to (5 bands
c                  * 10000 pixels per line) for
c                 GOES Imager areafiles, or (19 bands * 2631 pixels per line) 
c                 for GOES Sounder areafiles),
c                 fixed documentation and use of IMSAT (this is NOT the SSEC
c                 sensor source #!!!), but is just the GOES #
c
c 19 Sep 01  JPN  increased NC from 25 to 26, to account for GOES-12 Imager band 6
c 14 Sep 01  JPN  increased MXLN from 11 to 21, for AJS's cloud work...
c 31 Aug 01  JPN  version of gimdatx.for that works with "new" transmittance, GOES-I-M, word 26...
c 14 Feb 01  JPN  version of gimdatx.for that works with "new" transmittance
c                 model (PLOD or PFAAST) -- new FORMAT that handles the new
c                 GOES-M (GOES-12) imager with the 13.3 um channel ;
c                 also removed inline code, and performed some cleanup
c 16 Dec 99.. Evaluated for Y2K                     - JPN
c 24 Feb 99.. change date from yyddd to cyd for y2k. 
c 24 Sep 96.. Sub. "PFCOGX" for new tau replaces "PFCGIM" 
c 11 Oct 95.. in CHKIR.CHKVIS make 'no codicil msg' a ddest
c 11 Oct 95..   this is since the msg comes out w. each gimdat band!
c 22 Jun 95.. Added the check of IFAC being zero.
c 02 May 95.. Added COMMON/GMDTCT/ -- gimdat counts
c 02 May 95.. Added RELANG to COMMON /NAV/
c 17 Apr 95.. Added MXLN
c 10 Mar 95.. Added sounder detector number to LAST common block
c 09 Mar 95.. Get gain/bias info out of area (not hard-wired)
c 27 Feb.. make NWPL a parameter and increase to 15K
c 25 October..in line corrected GVAR_PFX
c 18Aug94 Check for negative radiance -- set to missing (Block)
c 15Aug94 Now picks up the albedo (whole %)
C
C $ SUBROUTINE GIMDATX_IM(IMLIN,IMELE,GDAT)             (CMH, JPN)
C $
C $ ACCESS GOES SOUNDER (OR "JOINED' IMAGER) FILE AND RETURN RADIANCE
C $ TEMPERATURES FOR AVAILABLE BANDS
C $
C $ IMLIN = (I) INPUT LINE (SATELLITE COORDINATES)
C $ IMELE = (I) INPUT ELEMENT
C $ GDAT  = (R) OUTPUT ARRAY OF BRIGHTNESS TEMPERATURES. HOWEVER,
C $             AN ENTRY OF GDAT(1)=-1. ALLOWS ACCESS OF NAVIGATION ONLY.
C $
C $     PRIMARY NAVIGATION (FOR IMLIN/IMELE) IS RETURNED IN COMMON/NAV/
C $
C $       RE-ENTRY, AS WHEN PROCESSING A "BOX" OF FOVs FOR A RETRIEVAL,
C $       IS CONTROLLED BY COMMON /AUTO/ TO MINIMIZE SUPERFLUOUS
C $       NAVIGATION AND I/O.  OPTIONS ARE:
C $
C $          IBOX=0 THIS ROUTINE WILL RETURN ONLY A SINGLE DATA VECTOR
C $          IBOX=1 RETURNS SEQUENTIAL DATA FOR SQUARE BOX OF SIZE NBXS--
C $                 IMLIN/IMELE ARE BOX CENTER; 1ST RETURN IS UPPER LEFT
C $          IBOX=2 RETURNS DATA FOR RECTANGLE OF ILU,ILL,IEL,IER ; 
C $                 THESE ARE PARAMETERS IN COMMON/AUTO/
C $
C $       IBOX IS RETURNED = 3 WHEN LAST DATA IN "BOX" IS PROCESSED.
C $       LASLIN AND LASELE IN COMMON /LAST/ ARE USED IN CONJUNCTION
C $       WITH IBOX FOR RE-ENTRY.  LASLIN SHOULD BE INITIALIZED < 0
C $       FOR A NEW LINE; LASELE SHOULD BE SIMILARLY INITIALIZED FOR
C $       A NEW RETRIEVAL "BOX".  ON RETURN FROM THIS SUBROUTINE, LASLIN &
C $       LASELE HAVE SATELLITE COORDINATES OF POINT PROCESSED; COINCIDENT
C $       NAVIGATION IS CONTAINED IN COMMON /DANGLE/.
C $
C $       IN ESSENCE, TO PROCESS A "BOX" OF DATA, INITIALIZE LASLIN, 
C $       LASELE & IBOX AND MAKE REPEATED CALLS UNTIL IBOX=3 IS RETURNED.
C $
C $$ GIMDAT = GIMS
C $
C $   This is experimental software, unsupported by SSEC
C
      include 'areaparm.inc'

CCC      PARAMETER (NC=25, NWPL=15000, MXLN=21)
      PARAMETER (NC=26, NWPL=50000, MXLN=21)      ! Increase NC (# of channels) to 26 for GOES-12 Imager band 6 - JPN
      PARAMETER (NA=5)
      PARAMETER (NB=5)

      INTEGER*2 LINDAT(NWPL,MXLN)

      INTEGER   IBAND,CHKIR_BAND,HVCOD
      INTEGER   CHKCOD                            ! core McIDAS-X function to check validity of CALIBRATION codicil
      INTEGER   SVGOFF, SVBOFF, SVAOFF, SVG2OFF
      INTEGER   NRIDGE,DRIDGE,MODELE,MAXELE,MINELE,PRIMCH,SECNCH,
     *          PCWATR,PCURBN
      INTEGER   IARR(128),KBUG
      INTEGER   YYYYDDD        ! function to convert date to ccyyddd format
C
C     NEWARR is the new factory coeff. array for visible data
C
      REAL*4    NEWARR(128) 
      REAL*4    ALB, VG2AVG, VGAVG, VBAVG, VALB 

      DOUBLE PRECISION DBLE    ! intrinsic FORTRAN function

      DIMENSION GDAT(NC),NIN(MXLN),LLIN(MXLN),KOUT(10)
      DIMENSION IDAT(NC),LCH(NC),MFR(64)
      DIMENSION XIN(4),XOUT(3)
      DIMENSION SCALE(NC)

      CHARACTER*1 CSAT
      CHARACTER*12  CFI,CFF    ! core McIDAS-X functions
      CHARACTER*17  PN
      CHARACTER*132 LBUF

C      COMMON/ARACOM/NAREA,AREAS(NA),NEL(NA),NOFF(NA),MAXSIZ(NA),
C     1 ARADIR(64,NA),NCALB(4,NA),OPTION(NB,NA),FLIP(NA)
C
C     FOLLOWING COMMUNICATES WITH VATOPO TO GIVE SURFACE CHARACTERISTICS
C
      COMMON /CMTOPO/ NRIDGE,DRIDGE,MODELE,MAXELE,MINELE,PRIMCH,SECNCH,
     1        PCWATR,PCURBN, ELEMOD,ELEMAX,ELEMIN
      COMMON /ARENT/IDIR(64)
      COMMON /AUTO/IBOX,ILU,ILL,IEL,IER,MAG     ! ILU,ILL,IEL,IER must be in image coordinates!
      COMMON /DANGLE/GLAT,GLON
      COMMON /DLIS/LISDAT
      COMMON /GMDTCT/ICOUNT(NC)
C
C     The following common block is set within GVAR_PFX.FOR. JD is
C     returned in ccyyddd format.  12/16/99- JPN
C
      COMMON /LAST/LASLIN,LASELE,LELE,ICHAR,JT,JD,IDET
      COMMON /NAV/FLAT,FLON,ZENLOC,SZEN,LL,LE,IRAS,IPIC,IHMS,JTIME,JDAY
CCC     1        ,RELANG
      COMMON /RADG/GRAD(NC)
C
C **** 'IMSAT' IS SSEC GOES I/M Satellite Number (8=GOES-8; 9=GOES-9, etc)
C
      COMMON /SIMSAT/IMSAT,IMAGE,IMODE,ISTEP
      COMMON /SIZE/NBXS
C
C ****IUCH IS FLAG ARRAY FOR CHANNEL AVAILABILITY; REASON FOR "2" IS TO
C     HAVE AVAILABLE "TEMPERATURE" AND "MOISTURE" VECTORS, BUT NOT
C     CURRENTLY USED
C
      COMMON /USE/IUCH(NC,2)

      COMMON /DBUG/KBUG
C
C     ADD COMMON /COUNT/ TO CARRY HISTOGRAM INFO
C
      CHARACTER*5 CSATC
      COMMON /COUNT/ IKOUNT(25),IICH,CSATC
C
C     OFFSETS INTO THE ARRAY RETURNED BY CHKVIS_IM()
C
      DATA IVGOFF/9/, IVBOFF/1/, IVAOFF/25/, IVG2OFF/17/ 
      DATA SVGOFF/5/, SVBOFF/1/, SVAOFF/13/, SVG2OFF/10/ 
      DATA IVPNT/0/
      DATA JDSAV/0/
CCC      DATA SCALE/12*100.,6*10000.,3*1.,10000.,3*100./
      DATA SCALE/12*100.,6*10000.,3*1.,10000.,4*100./     ! Add 1 value at end for GOES-12 Imager band 6- JPN
      DATA IARR/128*0/

      DATA PN/'(GIMDATX_IM.FOR)'/
C
C     FOLLOWING ARE IMAGE LINE AND ELEMENT
C
      IL=IMLIN
      IE=IMELE

      IF(KBUG.GE.5) THEN
         CALL SDEST(PN//'+++ Now entering routine: IMLIN,IMELE,'//
     *   'IBOX,LASLIN,LASELE=',0)
         CALL SDEST(CFI(IMLIN)//CFI(IMELE)//
     *   CFI(IBOX)//CFI(LASLIN)//CFI(LASELE),0)
         CALL SDEST(PN//'                          IBEG,NBXS   '//
     *   '                  =',0)
         CALL SDEST(CFI(IBEG)//CFI(NBXS),0)
      ENDIF

      IF(LASLIN.GE.0) GO TO 50   ! We've already processed at least one line of this data "box"...

      DO 20 N=1,MXLN
C
C        FOLLOWING ELEMENT IS FLAG FOR "TOPOGRAPHY LINE READ"...
C
         LLIN(N)=0
C
C        FOLLOWING ELEMENT IS FLAG FOR "DATA LINE READ"...
C
   20 NIN(N)=0

   50 CONTINUE

      IF(LASELE.LT.0) IBEG=0
C
C     IBEG IS SET TO ZERO FOR NEW ACCESS OF RETRIEVAL BOX (I.E., 
C     LASELE < 0) IN ORDER TO OBTAIN NAVIGATION (@ STATEMENT 1000).
C     AFTER NAVIGATION, IT IS SET TO 1 TO BEGIN ACCESSING DATA FROM THE
C     ARRAY LINDAT(1,IBEG).  THEREAFTER IT IS INCREMENTED EACH TIME
C     THE LINE IS INCREMENTED (SEE STATEMENTS JUST BEFORE STATEMENT 3100).
C
      IF(IBOX.EQ.0) LASLIN=-1         ! Return only a single data vector.
C
C     ABOVE NECESSARY TO SET OFFSET IN READING
C
      IF(IVPNT.NE.0) GO TO 1000       ! Skip the initialization stage!

      IF(KBUG.GE.5) THEN
         CALL SDEST(PN//
     *   ' ***** Now entering initialization code... *****',0)
      ENDIF

      IVPNT=1
      IFILE=IKWP('IAR',1,LUC(81))
      IF(IFILE.GT.0.AND.IFILE.LE.9999) GO TO 100

      CALL EDEST(PN//'ERROR: VAS POINTER IS SET TO '//
     *'INVALID SOUNDER-FILE '//CFI(IFILE)//'- ABORT!',0)
      CALL MCABORT

  100 CONTINUE
C
C     ACQUIRE NAVIGATION
C
      IF(NVSET('AREA',IFILE).NE.0) THEN
         CALL EDEST(PN//'ERROR: NAVIGATION NOT FOUND FOR '//
     *   'AREA '//CFI(IFILE)//'- ABORT!',0)
         CALL MCABORT
      ENDIF
C
C     READ DIRECTORY INFORMATION FROM SOUNDER FILE
C
C     1.  AREA STATUS:     <0  AREA DOES NOT EXIST
C                           0  AREA EXISTS
C     2.  TYPE:     0  UNDEFINED
C                   1  VISSR AREAS
C                   2  VAS SOUNDING (RAW BRIGHTNESS VALUES)
C                   3  AVHRR
C
C     NEW AREA TYPES ADDED 02/20/85 FOR NEW AREA STRUCTURE (RCD)
C                   4  AREAS (NEW STRUCTURE)
C     3.  SSS:     SATELLITE IDENTIFICATION NUMBER
C     4.  YYDDD:     NOMINAL YEAR AND JULIAN DAY OF AREA/SND
C     5.  HHMMSS:     NOMINAL TIME OF IMAGE/SND
C     6.  Y-COOR:     UPPER LEFT HAND LINE COORDINATE IN SATELLITE COORD
C     7.  X-COOR:     UPPER LEFT HAND ELEMENT COORDINATE IN SATELLITE CO
C     8.  Z-COOR:     UPPER LEFT HAND Z-COOR--NOT USED FOR AREAS
C     9.  Y-SIZE:     NUMBER OF LINES IN IMAGE
C     10.  X-SIZE:     NUMBER OF ELEMENTS IN IMAGE
C     11.  Z-SIZE:     NUMBER OF BYTES PER DATA ELEMENT ( 1 IF AREA)
C     12.  Y-RES:     LINE RESOLUTION
C     13.  X-RES:     ELEMENT RESOLUTION
C     14.  Z-RES:     Z RESOLUTION (NUMBER OF BANDS (CHANNELS))
C     15.  Y-Z PREFIX: NUMBER OF BYTES-MUST BE MULTIPLE OF 4 (0 IF AREA)
C     16.  PROJ:     PROJECT NUMBER THAT CREATED THE AREA
C     17.  CREATION DATE:     DAY AREA WAS CREATED IN YYDDD FORMAT
C     18.  CREATION TIME:     TIME AREA WAS CREATED IN HHMMSS FORMAT
C     19.   FILTER MAP: (FOR SOUNDINGS) A 13 BIT VECTOR
C                       IF A BIT=1 THERE IS DATA FOR THAT BAND IN THE
C                       FILE. THE RIGHTMOST BIT IS FOR BAND 1.
C     20.  IMAGE ID NUMBER:  OLD REEL NUMBER
C     21-24.  IDENTIFICATION:     (RESERVED FOR EXPANSION)
C              FOR RADAR 21,22=CALL  23=RANGE  24=#BAD LINES IN IMAGE
C              FOR METEOSAT  21-24 FOR CALIBRATION COEFFICIENTS
C              FOR GMS   21 - IR CALIBRATION ID
C              FOR SSMI  21 - # BLANK LINES
C     25-32.  MEMO ENTRY:     UP TO 32 CHARACTERS FOR COMMENTS
C     33.   PRIMARY KEY OF ASSOCIATED CALIBRATION CODICIL (AREA#)
C     34.   PRIMARY KEY OF ASSOCIATED NAVIGATION CODICIL
C     35.   SECONDARY KEY OF ASSOCIATED NAVIGATION CODICIL
C          (IF PRIMARY KEY .LE.0, USE (SSSYYDDD,HHMMSS) TO FETCH SYSTEM
C          NAVIGATION.)
C     36.  VALIDITY CODE:   CODE MUST MATCH LINE PREFIX (0=NO VAL CODE)
C     37-44.  PDL (IF THIS IMAGE MADE IN MODE AA) -PACKED BYTE FORMAT
C     45. WHERE BAND8 CAME FROM IF THIS IMAGE A MODE AA DS (STEP,DWELL)
C     46.   ACTUAL IMAGE START YYDDD
C     47.   ACTUAL IMAGE START HHMMSS
C     48.   ACTUAL STARTING SCAN
C
C     WORDS 49-53 ADDED 02/20/85 FOR NEW AREA STRUCTURE (RCD)
C     49.   LENGTH OF PREFIX DOCUMENTATION (DOC) SECTION IN BYTES
C     50.   LENGTH OF PREFIX CALIBRATION (CAL) SECTION IN BYTES
C     51.   LENGTH OF PREFIX LEVEL (LEV) SECTION IN BYTES (PER BAND)
C     52.   SOURCE TYPE ('VISR','VAS ','AVHR','ERBE', ...)
C     53.   CALIBRATION TYPE ('BRIT','RAW ','TEMP','RAD ',...)
C     54.   1= IMAGE WAS SAMPLED, 0=IMAGE WAS AVERAGED
C     55.   TIRO SIGNAL TYPE 'LAC', 'GAC' 'HRPT'
C     56.   TIRO ASSENDING DESCENDING 1=A 2=D 3=AD 4=DA
C     57.   ORIGINAL SOURCE TYPE OF DATA
C
C     58-64.  SYSTEM USE:     (RESERVED)
C
C     OPEN AREA
C
      CALL OPNARA(IFILE)

      CALL READD(IFILE,IDIR)
      IF(IDIR(1) .LT. 0) THEN
         CALL EDEST(PN//'ERROR: SOURCE AREA #'//CFI(INA)//
     *   ' DOES NOT EXIST- ABORT!',0)
         CALL MCABORT
      ELSE IF(IDIR(35).LE.0) THEN
         CALL EDEST(PN//'ERROR: SOURCE AREA #'//CFI(INA)//
     *   ' DOES NOT CONTAIN NAVIGATION INFORMATION- ABORT!',0)
         CALL EDEST(PN//'IDIR(35)='//CFI(IDIR(35)),0)
         CALL MCABORT
      ELSE IF(IDIR(34).LE.0) THEN
         CALL EDEST(PN//'ERROR: SOURCE AREA #'//CFI(INA)//
     *   ' DOES NOT CONTAIN ANY TYPE OF DATA- ABORT!',0)
         CALL EDEST(PN//'IDIR(34)='//CFI(IDIR(34)),0)
         CALL MCABORT
      ENDIF

      LENPFX = IDIR(15)/4
C
C     RETURN JDAY/JTIME
      JDAY=IDIR(3)*100000+IDIR(4)
c     remove SS in front of YYddd. 
C2000
ccjd      JDAY1=IDIR(4)    ! is in yyyddd format - 12/16/99- JPN
ccjd                       ! Therefore, on 12/16/1999, is       99350
ccjd                       !            on 1/1/2000,   will be 100001 
ccjd      ISTAT=YYYYDDD(JDAY1,JDAY1YYYYDDD)  ! Compute ccyyddd date equivalent for JDAY1
ccjd      IF(ISTAT.NE.0) THEN
ccjd         CALL EDEST(PN//'ERROR returned from YYYYDDD='//
ccjd     *   CFI(ISTAT)//' JDAY1='//CFI(JDAY1)//'- ABORT!',0)
ccjd         CALL MCABORT
ccjd      ELSE
ccjd         JDAY=JDAY1YYYYDDD  
ccjd      ENDIF

Ctn!  Calculte the minute from the idir(5) of area file
      JTIME=IDIR(5)
      JMIN=JTIME/100-((JTIME/10000)*100)
      JHR=JTIME/100-JMIN

Ctn! Set up csat for goes east or goes west
      IF(JMIN.EQ.00) THEN
         CSAT='W'
      ELSE IF (JMIN.EQ.15) THEN
         CSAT='E'
      ENDIF
C
C     READ CALIBRATION CODICIL OUT OF THE AREAFILE VIA ARAGET.
C
      HVCOD = 0                                  ! Assume we don't have a valid CAL codicil.
      IF(IDIR(63).GT.0) THEN
         IOFF   = IDIR(63)
         NBYTES = IDIR(34) - IDIR(63)
         CALL ARAGET(IFILE,IOFF,NBYTES,IARR)     ! Read calibration block into "IARR"
C
C        "have codicil" is indicated by HVCOD = 1
C
         HVCOD = 1
ccjd         HVCOD = CHKCOD(IARR)
      ENDIF

      IF(LISDAT.EQ.0.AND.KBUG.EQ.1) GO TO 500

      CALL SDEST(PN//'DIRECTORY (1st 21 words) FOR AREAFILE '//
     *CFI(IFILE)//':',0)

      KB=-1
      DO 400 KK=1,3
         KOUT(1)=7
         DO 300 K=2,8
  300    KOUT(K)=IDIR(K+KB)
         CALL OUTINT(KOUT)
  400 KB=KB+7

  500 CONTINUE
C
C     CHECK IF BACKGROUND JOB OR NON-VIDEO TERMINAL
C
ccjd      IF(LUC(-25).LT.1)         GO TO 700   ! Program is running in background...

ccjd      IF(LUC(16).EQ.0)          GO TO 700   ! Terminal is non-video...

ccjd      IF(IKWP('AUTO',1,0).NE.0) GO TO 700   ! We are running WITHOUT using a loaded image...

ccjd      NFR=LUC(-1)                           ! Current image frame
ccjd      CALL GETFRM(NFR,MFR)
ccjd      MAG=MFR(10)

ccjd      MDATE=MFR(2)                          ! Year/Julian date of image loaded from frame directory

CCC   IDATE=IDIR(4)                         ! Year/Julian date of image from image directory (yyyddd format)
                                            ! (Commented out on 2/14/2001 (JPN), because presumably frame dir.
                                            ! date is also in ccyyddd format, so we want subsequent comparison
                                            ! between MDATE and IDATE to be legitimate.)

ccjd      IDATE=JDAY                            ! Year/Julian date of image from image directory (ccyyddd format)

ccjd      IF(MDATE.NE.IDATE)    GO TO 600
C
C     ALSO CHECK TIME
C
ccjd      IF(MFR(3).NE.IDIR(5)) GO TO 600

      GO TO 700

  600 CALL EDEST(PN//'ERROR: SOUNDER-FILE AND IMAGE '//
     *'DO NOT AGREE- ABORT!',0)
      CALL EDEST(PN//'       MDATE(from frame dir.)='//CFI(MDATE)//
     *', IDATE(from area dir.)='//CFI(IDATE),0)
      CALL EDEST(PN//'       MFR(3)(from frame dir.)='//CFI(MFR(3))//
     *', IDIR(5)(from area dir.)='//CFI(IDIR(5)),0)
      CALL MCABORT

  700 CONTINUE
C
C     FIND OUT WHICH SOUNDER CHANNELS ARE IN USE
C
      DO 750 M=1,NC
         LCH(M)=0
  750 CONTINUE

      IOWD=IDIR(19)            ! areafile band map
      IWD=IOWD
      DO 800 I=1,19
         IF(MOD(IWD,2).EQ.0) GO TO 800
         LCH(I)=1
  800 IWD=IWD/2
C
C     GET NUMBER OF MEASUREMENTS PER FOV
C
C     GET OFFSET OF DATA RELATIVE TO SECTOR ZERO OF SOUNDER FILE
C
      ILOFF=IDIR(6)               ! upper-left image line    coordinate
      IEOFF=IDIR(7)               ! upper-left image element coordinate
      JRES=IDIR(12)               ! line resolution
      IRES=IDIR(13)               ! element resolution
      ISAT=IDIR(3)                ! SSEC sensor source number (e.g., GOES-8,12 Imager/Sounder = 70/71,78/79)
      INELE=IDIR(10)              ! # of data values per line in the input area
      NBAND=IDIR(14)              ! # of spectral bands       in the input area
      NELE=MIN0(INELE,NWPL/NBAND)

Ctn!  Added if the ISAT is 3 digits
      IF(ISAT.GT.100) ISAT=ISAT - 100

      IF(LISDAT.NE.0.OR.KBUG.NE.0) THEN
         CALL SDEST(PN//'IMLIN,IMELE           ='//CFI(IMLIN)//
     *   CFI(IMELE),0)
         CALL SDEST(PN//'ILOFF,IEOFF,JRES,IRES ='//CFI(ILOFF)//
     *   CFI(IEOFF)//CFI(JRES)//CFI(IRES),0)
         CALL SDEST(PN//'ISAT,INELE,NBAND,NELE ='//CFI(ISAT)//
     *   CFI(INELE)//CFI(NBAND)//CFI(NELE),0)
         CALL SDEST(PN//'IOWD (band map)       ='//CFI(IOWD),0)
      ENDIF
C
CTJS  READ SS, AND DECIDE IF IMAGER OR SOUNDER...
C
      IF(IDIR(52).EQ.LIT('GVAR')) THEN
         IF(MOD(IDIR(3),2).EQ.0) THEN
            IMAGE=1                             ! GOES Imager
            N=20
         ELSE
            IMAGE=0                             ! GOES Sounder
            N=0
         ENDIF
      ELSE
         IF(IDIR(52).EQ.LIT('GIMI')) THEN
            IMAGE=1
            N=20
         ELSE
            IMAGE=0
            N=0
         ENDIF
      ENDIF

      IF (LISDAT.NE.0.OR.KBUG.NE.0) THEN
         IF(IMAGE.EQ.0) THEN
            CALL SDEST(PN//'Sounder channels in use:',0)
            CALL SDEST(' ',0)
            WRITE(LBUF,'(''LCH: '',19I3)') (LCH(I),I=1,19)
            CALL LTQ(LBUF)
            CALL SDEST(' ',0)
         ELSE IF(IMAGE.EQ.1) THEN
            CALL SDEST(PN//'Imager channels in use:',0)
            CALL SDEST(' ',0)
            WRITE(LBUF,'(''LCH: '',19I3)') (LCH(I),I=1,19)
            CALL LTQ(LBUF)
            CALL SDEST(' ',0)
         ENDIF
      ENDIF

      ILIN=(IL-ILOFF)/JRES              ! Determine input line in area coordinates...

      IF (LISDAT.NE.0.OR.KBUG.NE.0) THEN
         CALL SDEST(PN//'ILIN (Input line in area coordinates):'//
     *   CFI(ILIN),0)
         CALL SDEST(' ',0)
      ENDIF

      CALL GVAR_PFX(IFILE,ILIN,LENPFX)  ! Read area line prefix...
c
c     imsat is filled after this call, as well as jt and jd in /LAST/
c     unless line prefix is missing or garbled
c
C      IF (IMSAT .EQ.0) IMSAT = 8
Ctn!      IF (IMSAT .EQ.0) IMSAT = 12
      IMSAT=((ISAT-70)/2)+8

      IF (JD .NE.0) THEN
         JD = IDIR(3)*100000 + JD
         JDSAV = JD                 ! ccyyddd format
         JTSAV = JT
      ELSE
         IF (JDSAV .NE. 0) THEN
            JD = JDSAV              ! ccyyddd format
            JT = JTSAV
         ELSE
            JD = JDAY               ! ccyyddd format
            JT = JTIME
         ENDIF
      ENDIF
C
C * Call twice in order to have new Ts coef's for sub. skingx.for (9/24/96)
C   (Commented out on 2/14/2001- JPN-- It appears that PFCGIM needed
C    to be called in the old GIMDATX.FOR because BRITGO (RTTOVS model!)
C    was being called below, and it required common block PLNCGO to be filled.)
C
C    At any rate, we will use GOESPFCO from now on!
C
C   *Note: GOESPFCO uses 26-word arrays (GOES-12 has an imager band 6, but NOT a band 5).
C
CCC      CALL PFCGIM(IMSAT)  ! RTTOVS model
CCC      CALL PFCOGX(IMSAT)  ! PLOD/PFAAST model, but no GOES-12 (M)
      CALL GOESPFCO(IMSAT)   ! PLOD/PFAAST model, including GOES-12 (M)
C
C     FILL USE FLAGS
C
      DO 900 M=1,NC
         IUCH(M,1)=0
  900 IUCH(M,2)=0

      DO 905 M=1,19
         IF(LCH(M).EQ.1) THEN
C
C           This channel exists in this areafile.
C
C           If area is Sounder, we will fill IUCH(1->19,1), if Imager, we will fill IUCH(21->26,1).
C           If area is Sounder, we will fill IUCH(1->19,2), if Imager, we will fill IUCH(21->26,2).
C
            IUCH(M+N,1)=1  
            IUCH(M+N,2)=1
         ENDIF
  905 CONTINUE

      IF (LISDAT.NE.0.OR.KBUG.NE.0) THEN
         IF(IMAGE.EQ.0) THEN
            CALL SDEST(PN//'Sounder use flags:',0)
            CALL SDEST(' ',0)
            WRITE(LBUF,'(''IUCH(1-19,1) '',19I3)') (IUCH(I,1),I=1,19)
            CALL LTQ(LBUF)
            WRITE(LBUF,'(''IUCH(1-19,2) '',19I3)') (IUCH(I,2),I=1,19)
            CALL LTQ(LBUF)
            CALL SDEST(' ',0)
         ELSE IF(IMAGE.EQ.1) THEN
            CALL SDEST(PN//'Imager use flags:',0)
            CALL SDEST(' ',0)
            WRITE(LBUF,'(''IUCH(21-26,1) '',6I3)') (IUCH(I,1),I=21,26)
            CALL LTQ(LBUF)
            WRITE(LBUF,'(''IUCH(21-26,2) '',6I3)') (IUCH(I,2),I=21,26)
            CALL LTQ(LBUF)
            CALL SDEST(' ',0)
         ENDIF
      ENDIF
C
C**** END INITIALIZATION SECTION; ENTER BELOW FOR ALL BUT THE
C     INITIAL CALL TO SUBROUTINE...
C
 1000 CONTINUE
C
C     PICK UP NAVIGATION WHEN BEGINNING RETRIEVAL BOX (IBEG=0)
C     OR WHEN REQUESTING SINGLE VECTOR (IBOX=0)
C
      IF((IBOX*IBEG).NE.0) GO TO 1500

      IF(KBUG.GE.5) THEN
         CALL SDEST(PN//
     *   ' ** Now entering navigation code... **',0)
      ENDIF

      FLIN=FLOAT(IL)
      FELE=FLOAT(IE)
C
C     CONVERT INPUT IMAGE/SATELLITE COORDINATES TO EARTH COORDINATES...
C
      IS=NV1SAE(FLIN,FELE,0.0,FLAT,FLON,FDUM)
      IF(IS.NE.0) THEN
C!!         CALL SDEST(PN//'ERROR returned from NV1SAE='//CFI(IS)//
C!!     *   '; FLAT/FLON will be set to 100./200., then continue on...',0)
         FLAT=100.
         FLON=200.
      ENDIF

      COSLAT=COS(FLAT*.0174532)   ! cosine of center latitude in radians
C
C     SAVE FOR APPROXIMATING LOCATIONS WITHIN BOX
C
C     CONVERT INPUT LINE AND ELEMENT SATELLITE COORDINATES TO AREA COORDINATES...
C
      ILIN=(IL-ILOFF)/JRES
      IELE=(IE-IEOFF)/IRES

      CALL GVAR_PFX(IFILE,ILIN,LENPFX)
C
C     return day/time for center of box
C
C      IF (IMSAT .EQ.0) IMSAT = 8
      IF (IMSAT .EQ.0) IMSAT = 12

      IF (JD .NE.0) THEN
         JD = IDIR(3)*100000 + JD
         JDSAV = JD                ! ccyyddd format
         JTSAV = JT
      ELSE
         IF (JDSAV .NE. 0) THEN
            JD = JDSAV             ! ccyyddd format
            JT = JTSAV
         ELSE
            JD = JDAY              ! ccyyddd format
            JT = JTIME
         ENDIF
      ENDIF
C
C     PICK UP ZENITH ANGLES
C
      XIN(1)=FLOAT(JD)    ! is in ccyyddd format- 12/16/99- JPN
      XIN(2)=FTIME(JT)
      XIN(3)=FLAT
      XIN(4)=-FLON

      IS=NV1OPT('ANG ',XIN,XOUT)
      IF(IS.NE.0) THEN
         CALL SDEST(PN//'ERROR returned from NV1OPT='//CFI(IS)//
     *   '-- continue on...',0)
      ENDIF
C
C     XOUT(1-3) are returned as the following variables in GVRANGgvarnv1:  SATANG, SUNANG, RELANG.
C
      ZENLOC=XOUT(1)
      SZEN=XOUT(2)
      RELANG=XOUT(3)

      IF(NINT(GDAT(1)).EQ.-1) THEN
         IF(KBUG.GE.5) THEN
            CALL SDEST(PN//
     *      ' *** Now leaving navigation code & GIMDATX_IM... ***',0)
            CALL SDEST(PN//'FLIN,FELE (sat. coord.) ='//
     *      CFF(DBLE(FLIN),4)//CFF(DBLE(FELE),4),0)
            CALL SDEST(PN//'FLAT,FLON (lat/lon)     ='//
     *      CFF(DBLE(FLAT),4)//CFF(DBLE(FLON),4),0)
            CALL SDEST(PN//'ILIN,IELE (area coord.) ='//CFI(ILIN)//
     *      CFI(IELE),0)
            CALL SDEST(PN//'ZENLOC,SZEN,RELANG      ='//
     *      CFF(DBLE(ZENLOC),4)//CFF(DBLE(SZEN),4)//
     *      CFF(DBLE(RELANG),4),0)
         ENDIF
         GO TO 3100      ! Exit the routine...
      ENDIF
C
C     NAV COMPLETE...ACQUIRE DATA AFTER SCALING DOWN FROM IMAGE COORDINATES.
C
      IF(LISDAT.EQ.0.AND.KBUG.EQ.0) GO TO 1200    ! Listing option is not active...

      CALL SDEST(PN//'IMAGE TO SOUNDER-FILE COORD-TRANSFORMATIONS',0)
      CALL SDEST(
     *'   ILOFF    JRES      IL    ILIN   IEOFF    IRES      IE    IELE'
     *,0)
      KOUT(1)=8
      KOUT(2)=ILOFF
      KOUT(3)=JRES
      KOUT(4)=IL
      KOUT(5)=ILIN
      KOUT(6)=IEOFF
      KOUT(7)=IRES
      KOUT(8)=IE
      KOUT(9)=IELE
      CALL OUTINT(KOUT)

 1200 CONTINUE
C
C     FOLLOWING ARE SOUNDER FILE LINE AND ELEMENT-- SAVE FOR CENTER POINT.
C
      MLIN  = ILIN
      MELE  = IELE
      IBEG  =  1
      ILINL = -1
      LSECL = -1
C
C     SET UP FACTOR FOR HIGH RESOLUTION SOUNDER FILES
C
      IFAC=JRES/IRES              ! (line resolution / element resolution-- usually = 1)
C
C     ifac cannot be zero, because we divide by it later.
C
      if (ifac.eq.0) ifac=1

      IF(KBUG.GE.5) THEN
         CALL SDEST(PN//' IFAC(line res./element res.) ='//CFI(IFAC),0)
      ENDIF

      IF(IBOX.EQ.0) THEN
         IF(KBUG.GE.5) THEN
            CALL SDEST(PN//' * IBOX = 0-- Return '//
     *      'only a single data vector (GOTO 1500)...',0)
         ENDIF
         GO TO 1500    ! RETURN ONLY A SINGLE DATA VECTOR.
      ENDIF

      IF(IBOX.EQ.2) THEN
         IF(KBUG.GE.5) THEN
            CALL SDEST(PN//' * IBOX = 2-- Return '//
     *      'a rectangle of data (GOTO 1300)...',0)
         ENDIF
         GO TO 1300    ! RETURN DATA FOR A RECTANGLE OF ILU,ILL,IEL,IER (IMAGE COORDINATES!)
                       ! (THESE ARE PARAMETERS IN COMMON/AUTO/)
      ENDIF

      IF(KBUG.GE.5) THEN
         CALL SDEST(PN//' * IBOX ='//CFI(IBOX)//'...',0)
         IF(IBOX.EQ.1) THEN
            CALL SDEST(PN//'   Return a box of data of size'//
     *      CFI(NBXS)//' X '//CFI(NBXS),0)
         ENDIF
      ENDIF

      IF(NBXS.EQ.0) THEN
         NBXS=5        ! box size,   in pixels (i.e., area coordinates)
      ENDIF

      IBOFF=(NBXS-1)/2            ! box offset, in pixels 

      ILB=MLIN-IBOFF              ! beginning box  area  line    coordinate
      ILE=MLIN+IBOFF              ! ending    box  area  line    coordinate
      IEB=MELE-IBOFF*IFAC         ! beginning box  area  element coordinate
      IEE=MELE+IBOFF*IFAC         ! ending    box  area  element coordinate


CCC      ILOFF=IDIR(6)            ! upper-left     image line    coordinate
CCC      IEOFF=IDIR(7)            ! upper-left     image element coordinate

      ILU=ILOFF+ILB*JRES          ! beginning box  image line    coordinate  
      ILL=ILOFF+ILE*JRES          ! ending    box  image line    coordinate
      IEL=IEOFF+IEB*IRES          ! beginning box  image element coordinate
      IER=IEOFF+IEE*IRES          ! ending    box  image element coordinate


      IF(KBUG.GE.5) THEN
         CALL SDEST(PN//'   (Just b4 1300) NBXS,IBOFF     ='//
     *   CFI(NBXS)//CFI(IBOFF),0)
         CALL SDEST(PN//'   ILB,ILE,IEB,IEE (area coord.) ='//
     *   CFI(ILB)//CFI(ILE)//CFI(IEB)//CFI(IEE),0)
         CALL SDEST(PN//'   ILU,ILL,IEL,IER (image coord.)='//
     *   CFI(ILU)//CFI(ILL)//CFI(IEL)//CFI(IER),0)
      ENDIF

      GO TO 1400

 1300 CONTINUE

      ILB=(ILU-ILOFF)/JRES        ! beginning rectangle area line    coordinate
      ILE=(ILL-ILOFF)/JRES        ! ending    rectangle area line    coordinate
      IEB=(IEL-IEOFF)/IRES        ! beginning rectangle area element coordinate
      IEE=(IER-IEOFF)/IRES        ! ending    rectangle area element coordinate

      IF(KBUG.GE.5) THEN
         CALL SDEST(PN//'   ILU,ILL,IEL,IER (image coord.)='//
     *   CFI(ILU)//CFI(ILL)//CFI(IEL)//CFI(IER),0)
         CALL SDEST(PN//'   ILB,ILE,IEB,IEE (area coord.) ='//
     *   CFI(ILB)//CFI(ILE)//CFI(IEB)//CFI(IEE),0)
      ENDIF

 1400 CONTINUE
C
C     INITIALIZE LINE AND ELEMENT FOR UPPER LEFT OF RETRIEVAL BOX--
C     THESE ARE IN AREA COORDINATES...
C
      ILIN=ILB
      IELE=IEB

      IF(KBUG.GE.5) THEN
         CALL SDEST(' ',0)
         CALL SDEST(PN//'   ILIN,IELE (area coord.)='//
     *   CFI(ILIN)//CFI(IELE),0)
      ENDIF
C
C     ***********************************
C     END INITIALIZATION OF RETRIEVAL BOX
C     ***********************************
C
C     SUBSEQUENT ENTRIES WITHIN BOX ENTER BELOW;
C     ILIN AND IELE ARE UPDATED AFTER
C     DATA ACCESS (FOLLOWING STATEMENT 2900).
C
 1500 CONTINUE

      DO 2100 I=1,NC
         GDAT(I)=999999.
         GRAD(I)=999999.
         IDAT(I)=0
 2100 CONTINUE

      IF(ILIN.LT.0) THEN
         IF(KBUG.GE.5) THEN
            CALL SDEST(PN//'  *Skip this area line-- we '//
     *      'are NORTH of the areafile...',0)
         ENDIF
         GO TO 2700       ! We're north of the top of the areafile.
      ENDIF

      IF(IELE.LT.0) THEN
         IF(KBUG.GE.5) THEN
            CALL SDEST(PN//'  *Skip this area line-- we '//
     *      'are WEST of the areafile...',0)
         ENDIF
         GO TO 2700       ! We're west  of the west side of the areafile.
      ENDIF

      IF(ILIN.EQ.ILINL) THEN
         IF(KBUG.GE.5) THEN
            CALL SDEST(PN//'  *Area line'//CFI(ILIN)//
     *      ' has ALREADY been read-- process it...',0)
         ENDIF
         GO TO 2000
      ENDIF

      ILINL = ILIN    ! Store the area line coordinate of the area line last read...
C
C     PICK UP A LINE OF DATA...
C
      IF(NIN(IBEG).NE.0) THEN
         IF(KBUG.GE.5) THEN
            CALL SDEST(PN//'  *Area line'//CFI(ILIN)//
     *      ' has ALREADY been read-- process it...',0)
         ENDIF
         GO TO 2000   
      ENDIF
C
C     NIN ("DATA LINE READ" FLAG) GETS SET AFTER CALL TO VATOPO
C
      IF(LASLIN.LT.0)   JOFF = IELE   ! We are only returning a single data vector...

      IF(JOFF.GT.NELE)  THEN
         IF(KBUG.GE.5) THEN
            CALL SDEST(PN//'  *Skip this area line-- we '//
     *      'are EAST of the areafile...???',0)
         ENDIF
         GO TO 2700
      ENDIF
C
C**** Read the line of data from the areafile.  After the call to REDARA, the array LINDAT 
C     will contain data calibrated in the area's native calibration.
C
C     IFILE = areafile to read
C     ILIN  = area line to read
C     JOFF  = area element to start reading at
C     NELE  = # of area elements to return
C
      CALL REDARA(IFILE,ILIN,JOFF,NELE,'ALL ',LINDAT(1,IBEG))

      IF(KBUG.GE.5) THEN
         CALL SDEST(PN//' Area'//CFI(IFILE)//' line'//
     *   CFI(ILIN)//' just read w/REDARA, starting with element'//
     *   CFI(JOFF),0)
         CALL SDEST(PN//' # of elements returned='//CFI(NELE)//
     *   ', stored in column LINDAT(1,'//CFI(IBEG)//')',0)
         CALL SDEST(PN//' All bands for 1st pixel (native CAL)=',0)  
         DO 1950 M=1,NBAND
            CALL SDEST(PN//'LINDAT('//CFI(M)//','//CFI(IBEG)//')= '//
     *      CFI(INT(LINDAT(M,IBEG))),0)
 1950    CONTINUE 
      ENDIF

 2000 CONTINUE


      IF(KBUG.GE.5) THEN
         CALL SDEST(PN//' b4 Do-loop 2300: loop bounds ='//
     *   ' 1 to IFAC (='//CFI(IFAC)//')',0)
      ENDIF

      DO 2300 NRES=1,IFAC

         IBYTE=1-JOFF*NBAND+(IELE+NRES-1)*NBAND

         IF(KBUG.GE.5) THEN
            CALL SDEST(PN//' In Do-loop 2300: IBYTE,NBAND='//
     *      CFI(IBYTE)//CFI(NBAND),0)
         ENDIF

         IF((IBYTE+18).GT.NWPL) THEN
            IF(LISDAT.NE.0.OR.KBUG.NE.0) THEN
               CALL SDEST(PN//'ATTEMPT TO READ OFF END OF LINE--'//
     *         ' GOTO 2800...',0)
            ENDIF
            GO TO 2800
         ENDIF

         DO 2200 I=1,NBAND
C
C           OLD.... IDAT(I)=(LINDAT(IBYTE,IBEG)+IDAT(I)
C           CALLING SIGNED TO TRANSFER EACH I*2 VALUE TO THE CORRESPONDING I*4 NUMBER....
C
            CALL SIGNED(LINDAT(IBYTE,IBEG),IDAT(I))
            IBYTE=IBYTE+1
 2200    CONTINUE

 2300 CONTINUE

      IF(KBUG.GE.5) THEN
         CALL SDEST(PN//' All bands for 1st pixel (after SIGNED)=',0)  
         DO 2350 M=1,NBAND
            CALL SDEST(PN//'IDAT('//CFI(M)//')= '//CFI(IDAT(M)),0)
 2350    CONTINUE 
      ENDIF

      I=0

      DO 2500 K=1,19

         IF(LCH(K).NE.1)  GO TO 2500    ! This channel IS NOT in this areafile-- process the next channel...

         I=I+1

         IDAT(I)=IDAT(I)/IFAC           ! Store the raw area data...  Note that GOES-12 Imager band 6 data will be
         IKOUNT(K) = IDAT(I)
                                        !                             stored in IDAT(5) via REDARA!!!  JPN

         IF(IDAT(I).LE.0) GO TO 2500    ! There is some type of problem-- process the next channel...

         IF(KBUG.GE.5) THEN
            CALL SDEST(' ',0)
            CALL SDEST(PN//'(DL2500) K,I,IDAT(I)='//CFI(K)//
     *      CFI(I)//CFI(IDAT(I)),0)
         ENDIF

         IF(IMAGE.NE.0) THEN
C
C           *************************
C           CALIBRATE RAW IMAGER DATA
C           *************************
C
Ctn! Use CSAT to avoid the problem when using diff. sattelite ID number
Ctn!            IF(ISAT.LT.78) THEN
               IF (CSAT.EQ.'E') THEN
C
C              GOES-8, 9, 10, 11
C
               IF(K.GT.5) THEN
                  GO TO 2500         ! The Imager only has 5 channels-- go to end of loop...
               ELSE
                  IBAND = K          ! Store the band number...
                  CHKIR_BAND = IBAND ! Gain and bias scaling factor calibration codicil locations are indicated by band #
               ENDIF
            ELSE IF (CSAT.EQ.'W') THEN 
C
C              GOES-12, 13, etc.
C
               IF(K.GT.6) THEN
                  GO TO 2500       ! The Imager only has 5 channels, but allow for ch.6 on GOES-12, 13, etc.-- go to end of loop...
               ELSE IF(K.EQ.6) THEN
                  IBAND = K          ! Store the band number...
                  CHKIR_BAND = 5     ! Gain and bias scaling factor calibration codicil locations for band 6 are stored where the band 5 gain/bias scaling factors were stored for GOES-8 -> 11...
               ELSE
                  IBAND = K          ! Store the band number...
                  CHKIR_BAND = IBAND ! Gain and bias scaling factor calibration codicil locations are indicated by band #
               ENDIF
            ENDIF        

CTJS
C---        IR BANDS      ***    IMAGER ONLY    ***
C
C           Now get the gain/bias right out of the area (via CHKIR_IM)
C
            IF(KBUG.GE.5) THEN
               CALL SDEST(PN//'(DL2500-IMAGER,B4 CHKIR_IM) IBAND,'//
     *         'CHKIR_BAND,ISAT,HVCOD=',0)
               CALL SDEST(CFI(IBAND)//CFI(CHKIR_BAND)//
     *         CFI(ISAT)//CFI(HVCOD),0)
            ENDIF

            if (iband.ne.1) then
CCC               CALL CHKIR(ISAT, IBAND, IARR, GAIN, BIAS, HVCOD)
Ctn!               CALL CHKIR_IM(ISAT,CHKIR_BAND,IARR,GAIN,BIAS,HVCOD)
               CALL CHKIR_IM(ISAT,CHKIR_BAND,IARR,GAIN,BIAS,HVCOD,CSAT)
            endif

C     ******************************
C---        DO THE RADIANCE CALCULATION
C     (HANDLES REAL OR SIMULATED IMAGER DATA)
CTJS  ******************************

            IBAND=K+20                         ! IBAND = 21-25 for GOES-8->11, but 21-24 & 26 for GOES-12

            IF(IDIR(52).EQ.LIT('GVAR')) THEN
C
C              Add counts to a Common array.
C
               ICOUNT(IBAND)= IDAT(I)/32
               GRAD(IBAND)=(FLOAT(IDAT(I)/32)-BIAS)/GAIN
            ELSE
               GRAD(IBAND)=FLOAT(IDAT(I))/SCALE(IBAND)
            ENDIF
c
c           Doing Visible channel
c
            IF(K.EQ.1) THEN
C
C              Code below is from kbxgvar.dlm...
C
C              CHECK THE VISIBLE COEFFICIENTS IN CODICIL AGAINST 
C              FACTORY.  COEFFICIENTS ARE RETURNED IN NEWARR. 
C              Visible Gain2, Gain and Bias  
C
               VG2AVG = 0 
               VGAVG = 0 
               VBAVG = 0 

               CALL CHKVIS_IM(ISAT, IARR, NEWARR, HVCOD) 

               DO 202 ITEMP=1,8 
                  VG2AVG = VG2AVG + NEWARR(ITEMP+IVG2OFF-1) 
                  VGAVG  = VGAVG  + NEWARR(ITEMP+IVGOFF-1) 
                  VBAVG  = VBAVG  + NEWARR(ITEMP+IVBOFF-1) 
  202          CONTINUE 

               VG2AVG = VG2AVG / 8.0 
c
c              call sdest('VG2AVG = '//cff(dble(VG2AVG),4),0)
c
               VGAVG = VGAVG / 8.0 
c
c              call sdest('VGAVG = '//cff(dble(VGAVG),4),0)
c
               VBAVG = VBAVG / 8.0 
c
c              call sdest('VBAVG = '//cff(dble(VBAVG),4),0)
c
               VALB = NEWARR(IVAOFF) 
c
c              call sdest('VALB = '//cff(dble(VALB),4),0)
c
C              COMPUTE ALBEDOS 
C
               ALB = ((IDAT(I)/32.0)**VG2AVG + (IDAT(I)/32.0 * VGAVG)
     *         + VBAVG) * VALB 
               IF(ALB .LT. 0.0) ALB = 0.0 
               alb = nint(alb*100)
               GRAD(IBAND) = NINT(ALB * 1) 
               GDAT(IBAND)=  NINT(GRAD(IBAND))
               GO TO 2500                        ! Process next channel...
            ENDIF

            IF (GRAD(IBAND).LE.0.) THEN
               GDAT(IBAND)=999999.
            ELSE
CCC               GDAT(IBAND)=BRITGO(GRAD(IBAND),IBAND) ! Compute brightness temperature...
               GDAT(IBAND)=GOESBRIT(GRAD(IBAND),IBAND) ! Compute brightness temperature...
            ENDIF

            IF(KBUG.GE.5) THEN
               CALL SDEST(PN//'(DL2500-IMAGER,AFTER CHKIR_IM) '//
     *         'GAIN,BIAS,'//
     *         'HVCOD,IBAND,GRAD(IBAND),GDAT(IBAND)=',0)
               CALL SDEST(CFF(DBLE(GAIN),2)//CFF(DBLE(BIAS),2)//
     *         CFI(HVCOD)//CFI(IBAND)//
     *         CFF(DBLE(GRAD(IBAND)),2)//CFF(DBLE(GDAT(IBAND)),2),0)
            ENDIF

         ELSE
C
C           **************************
C           CALIBRATE RAW SOUNDER DATA
C           **************************
C
            IF(IDIR(52).EQ.LIT('GVAR')) THEN
C
C---           FOR THE SOUNDER; FROM CHAD
c              Now get the gain/bias right out of the area (via CHKIR_IM)
c
               IBAND=K

               IF(KBUG.GE.5) THEN
                  CALL SDEST(PN//'(DL2500-SOUNDER,B4 CHKIR_IM) IBAND,'//
     *            'ISAT,HVCOD='//CFI(IBAND)//CFI(ISAT)//CFI(HVCOD),0)
               ENDIF

               if (iband.ne.19) then
                  CALL CHKIR_IM(ISAT,IBAND,IARR,GAIN,BIAS,HVCOD,CSAT)
               endif
c
c              Doing Visible channel
c
               IF (IBAND .EQ. 19) THEN
C
C                 CHECK THE VISIBLE COEFFICIENTS IN CODICIL AGAINST 
C                 FACTORY.  COEFFICIENTS ARE RETURNED IN NEWARR. 
C                 Visible Gain2, Gain and Bias  
C
                  VG2AVG = 0 
                  VGAVG = 0 
                  VBAVG = 0 

                  CALL CHKVIS_IM(ISAT, IARR, NEWARR, HVCOD)

                  DO 102 ITEMP=1,4 
                     VG2AVG = VG2AVG + NEWARR(ITEMP+SVG2OFF-1) 
                     VGAVG  = VGAVG  + NEWARR(ITEMP+SVGOFF-1) 
                     VBAVG  = VBAVG  + NEWARR(ITEMP+SVBOFF-1) 
102               CONTINUE 

                  VG2AVG = VG2AVG / 4.0 
                  VGAVG = VGAVG / 4.0 
                  VBAVG = VBAVG / 4.0 
                  VALB = NEWARR(SVAOFF) 
C
C                 COMPUTE ALBEDOS 
C
                  ALB = ((IDAT(I)/8.0)**VG2AVG + (IDAT(I)/8.0 * VGAVG) 
     *            + VBAVG) * VALB 
                  IF(ALB .LT. 0.0) ALB = 0.0 
                  alb = nint(alb*100)
                  GRAD(IBAND) = NINT(ALB * 1) 
                  GDAT(IBAND)=  NINT(GRAD(IBAND))
                  GO TO 2500                     ! Process next channel...
               ENDIF 
C
C              Add counts to a Common array.
C
               ICOUNT(IBAND)= IDAT(I)
C
C              NEED TO JUST MAKE THE RAW DATA POSTIVE....IF LARGE
C
               GRAD(IBAND)=(FLOAT(IDAT(I))-BIAS)/GAIN   ! Compute radiance for this channel...
            ELSE
               GRAD(IBAND)=FLOAT(IDAT(I))/SCALE(IBAND)
            ENDIF

            IF (GRAD(IBAND).LE.0.) THEN
               GDAT(IBAND)=999999.
            ELSE
CCC               GDAT(IBAND)=BRITGO(GRAD(IBAND),IBAND)  ! Compute brightness temperature...
               GDAT(IBAND)=GOESBRIT(GRAD(IBAND),IBAND)  ! Compute brightness temperature...
            ENDIF

            IF(KBUG.GE.5) THEN
               CALL SDEST(PN//'(DL2500-SOUNDER,AFTER CHKIR_IM) '//
     *         'GAIN,BIAS,'//
     *         'HVCOD,IBAND,GRAD(IBAND),GDAT(IBAND)=',0)
               CALL SDEST(CFF(DBLE(GAIN),2)//CFF(DBLE(BIAS),2)//
     *         CFI(HVCOD)//CFI(IBAND)//
     *         CFF(DBLE(GRAD(IBAND)),2)//CFF(DBLE(GDAT(IBAND)),2),0)
            ENDIF

         ENDIF

 2500 CONTINUE

      GO TO 2800

 2700 GDAT(1)=-1.

 2800 IF(IBOX.EQ.0) THEN
C
C        We're only doing a single data vector...
C
         GLAT= FLAT
         GLON= FLON
         GO TO 2850
      ENDIF
C
C     GET SATELLITE LINE AND ELEMENT FOR CURRENT FOV
C
      LASLIN = ILOFF+ILIN*JRES
      IL     = LASLIN
      LASELE = IEOFF+IELE*IRES
      IE     = LASELE
C
C     GET NAVIGATION AND ELEVATION FOR INDIVIDUAL POINTS--
C     ACCOUNT FOR APPROXIMATE OFFSET FROM CENTER POINT
C
      DE=FLOAT(IE-IMELE)
      DL=FLOAT(IL-IMLIN)
C
C     A MORE NORTHERN LINE    GIVES A NEGATIVE DL
C     A MORE WESTERN  ELEMENT GIVES A NEGATIVE DE
C
      GLAT=FLAT-DL/111.
      GLON=FLON-DE/(111.*COSLAT)

 2850 LATT=NINT(GLAT*100.)
      LONN=-NINT(GLON*100.)
C
C     CHECK FOR SPACE LOOK AND DO NOT INITIALIZE TOPO BUFFERS
C
      IF(GLAT.GT.90.) THEN
         GO TO 2900
      ENDIF

      CALL HRTOPO (LATT,LONN,LELE,ICHAR)
ccjd      CALL VATOPO (LATT,LONN,LELE,ICHAR)
C
C     PASS BACK CHARACTERISTIC AS:
C         0  OCEAN
C         1  LAND
C         2  DESERT
C         3  MARSH OR LAKE TYPE
C         4  LARGE (GREAT LAKE)
C
      IF (ICHAR.EQ.4 .AND. PCWATR.LT.95) ICHAR=3
C
 2900 IF (IBOX .EQ. 0) GO TO 3100    ! We're only doing a single data vector...

      IF(GDAT(1).NE.-1.) NIN(IBEG) = 1

      IELE = IELE + IFAC

      IF(IELE.LE.IEE)  THEN
         GO TO 3100
      ENDIF

      ILIN = ILIN+1      ! Increment number of line to process
      IBEG = IBEG+1      ! Increment index to store next area line of imagery in next column of LINDAT
C
C     TRAP AT MAX LINE AND BARK WARNING
C
      IF (IBEG .GT. MXLN) THEN
         CALL SDEST(PN//'WARNING! YOU ARE EXCEEDING '//
     *   'LINE STORAGE LIMIT OF '//CFI(MXLN),0)
         GO TO 3100
      ENDIF

      IELE = IEB
      IF(ILIN.LE.ILE) THEN
         GO TO 3100
      ENDIF

      IBOX=3

 3100 CONTINUE

      IF(KBUG.GE.5) THEN
         CALL SDEST(PN//'+++ Now exiting  routine: IMLIN,IMELE,'//
     *   'IBOX,LASLIN,LASELE=',0)
         CALL SDEST(CFI(IMLIN)//CFI(IMELE)//
     *   CFI(IBOX)//CFI(LASLIN)//CFI(LASELE),0)
         CALL SDEST(PN//'                          IBEG,NBXS   '//
     *   '                  =',0)
         CALL SDEST(CFI(IBEG)//CFI(NBXS),0)
      ENDIF

      RETURN
      END
