      FUNCTION LWREAD(LUN, NRECRD, JBUF)                                        
C                                                                               
C $ FUNCTION LWREAD(LUN, NRECRD, JBUF)                                          
C $ READ LW FILE                                                                
C $ LUN    = (I*4) LOGICAL UNIT NUMBER                                          
C $ NRECRD = (I*4) RECORD NUMBER                                                
C $ JBUF   = (I*4) OUTPUT BUFFER                                                
C $ LWREAD FUNCTION VALUE = 1 - RECORD SUCCESSFULLY READ                        
C $                         0 - NO DATA AVAILABLE                               
C $                        -1 - UNIT NOT ASSIGNED                               
C $                        -2 - RECORD ZERO OR NEGATIVE                         
C $                                                                             
      REAL*8 DNAMES, DFILE                                                      
      CHARACTER*80 CTEXT                                                        
      CHARACTER*8 CFNAME                                                        
      DIMENSION JBUF(2)                                                         
C                                                                               
      COMMON /DAIO/ DNAMES(16),LRECL(16),LUNS(16),JROFF(16),JWOFF(16),          
     1  KPROT(16)                                                               
      EQUIVALENCE (CFNAME,DFILE)                                                
      DATA NULL / Z'80808080'/ 
      LWREAD = 1                                                                
C                                                                               
      DO 100 J = 1, 16                                                          
        JJ = J                                                                  
        IF (LUNS(J) .EQ. LUN) GO TO 200                                         
  100 CONTINUE                                                                  
C                                                                               
C     LWREAD ERROR - LOGICAL UNIT NUMBER NOT ASSIGNED                           
C                                                                               
      WRITE(CTEXT,1000) LUN                                                     
      CALL SDEST(CTEXT,0)                                                       
      LWREAD = -1                                                               
      GO TO 900                                                                 
C                                                                               
  200 CONTINUE                                                                  
      DFILE = DNAMES(JJ)                                                        
      NREC = NRECRD + JROFF(JJ)                                                 
      IF (NREC .LE. 0) THEN                                                     
C                                                                               
C       LWREAD ERROR - RECORD NUMBER ZERO OR NEGATIVE                           
C                                                                               
        WRITE(CTEXT,2000) DFILE, NREC                                           
        CALL SDEST(CTEXT,0)                                                     
        LWREAD = -2                                                             
        GO TO 900                                                               
      ENDIF                                                                     
      JWORD = (NREC-1)*LRECL(JJ) + JWOFF(JJ)                                    
      JSTAT = LWI(CFNAME, JWORD, LRECL(JJ), JBUF)                               
      IF (JSTAT .NE. 0) THEN                                                    
C                                                                               
C       LWREAD ERROR - NO DATA AVAILABLE                                        
C                                                                               
        WRITE(CTEXT,3000) DFILE, NREC                                           
        CALL SDEST(CTEXT,0)                                                     
        LWREAD = 0                                                              
      ENDIF                                                                     
  900 CONTINUE                                                                  
      RETURN                                                                    
 1000 FORMAT(' LWREAD ERROR - UNIT ',I4,' NOT ASSIGNED')                        
 2000 FORMAT(' LWREAD ERROR FOR FILE ',A8,' - RECORD ',I4,                      
     1    ' CANNOT BE ZERO OR NEGATIVE')                                        
 3000 FORMAT(' LWREAD ERROR FOR FILE ',A8,' - RECORD ',I4,                      
     1    ' HAS NO AVAILABLE DATA')                                             
      END                                                                       
