C Copyright(c) 1997, Space Science and Engineering Center, UW-Madison
C Refer to "McIDAS Software Acquisition and Distribution Policies"
C in the file  mcidas/data/license.txt

C *** $Id: mdopen.f,v 1.14 2003/03/26 21:37:15 daves Exp $ ***

*$ Name:
*$	mdopen - opens a MD file
*$
*$ Interface:
*$	integer function
*$	mdopen(integer mdno, integer access)
*$
*$ Input:
*$	mdno	- MD file number
*$	access	- unused parameter
*$
*$ Input and Output:
*$	none
*$
*$ Output:
*$	none
*$
*$ Return values:
*$	 0	- success, MD file opened
*$	<0	- failure, unable to open MD file
*$
*$ Remarks:
*$	none
*$
*$ Categories:
*$	point
      INTEGER FUNCTION MDOPEN(MDNO,ACCESS)
      IMPLICIT NONE
      INTEGER MDNO
      INTEGER ACCESS

C --- symbolic constants & shared data

      INTEGER    MAXHED
      PARAMETER (MAXHED=5)

      INTEGER    HEDSIZ
      PARAMETER (HEDSIZ=64)

      INTEGER    MINMDFILE
      PARAMETER (MINMDFILE=1)

      INTEGER    MAXMDFILE
      PARAMETER (MAXMDFILE=999999)

C-----FOLLOWING COMMON BLOCK GIVES LAYOUT OF FILE HEADER.
      INTEGER SNAME
      INTEGER SVSN
      INTEGER SDATE
      INTEGER NR
      INTEGER NC
      INTEGER NKEYS
      INTEGER NRKEYS
      INTEGER NCKEYS
      INTEGER NDKEYS
      INTEGER CPOS
      INTEGER DPOS
      INTEGER NREPS
      INTEGER REPSIZ
      INTEGER REPPOS
      INTEGER MDATA
      INTEGER ID
      INTEGER TEXTID(8)
      INTEGER CPROJ
      INTEGER CDATE
      INTEGER COWNER
      INTEGER FRHOF
      INTEGER FCHOF
      INTEGER FDATOF
      INTEGER FENDOF
      INTEGER FUSROF
      INTEGER FNAMOF
      INTEGER FSCAOF
      INTEGER FUNIOF
      INTEGER UNUSED(26)
      INTEGER CFNAM(2)
      INTEGER CMDNO
      INTEGER MDHED(64,5)
      INTEGER BUF(400)
      COMMON/MDCOM/ SNAME,SVSN,SDATE,NR,NC,NKEYS,NRKEYS,NCKEYS,NDKEYS,
     &   CPOS,DPOS,NREPS,REPSIZ,REPPOS,MDATA,ID,TEXTID,CPROJ,CDATE,
     &   COWNER,FRHOF,FCHOF,FDATOF,FENDOF,FUSROF,FNAMOF,FSCAOF,
     &   FUNIOF,UNUSED,CFNAM,CMDNO,MDHED,BUF

C --- external functions

      INTEGER ISMFMT
      INTEGER LWFILE
      INTEGER LWI

C --- local variables

C      CHARACTER*512 CNAME
      CHARACTER*12 CNAME
      INTEGER FLIP
      INTEGER I
      INTEGER N
      
      IF (MDNO.LT.MINMDFILE.OR.MDNO.GT.MAXMDFILE) THEN
         MDOPEN=-1
         RETURN
      ENDIF

      CALL MDINIT

c--- Verify if the file exists or not
      call mdfilename(mdno, cname)

C--- Check for existance of file...
      IF (LWFILE(CNAME).EQ.0) THEN
         MDOPEN=-1
         RETURN
      ENDIF

      DO 4 I=1,MAXHED
         IF (MDNO.NE.MDHED(HEDSIZ,I)) GOTO 4
         CALL MOVW(HEDSIZ,MDHED(1,I),SNAME)
         MDOPEN=0
         RETURN
4     CONTINUE

      DO 7 N=1,MAXHED
         IF (MDHED(HEDSIZ,N).LE.0) GOTO 5
7     CONTINUE

C --- NO ROOM IN TABLES; mcABORT U040, HEX 40 = DEC 64
      CALL mcABORT(64)

5     CONTINUE

C --- Check for flipped bytes
      FLIP = ISMFMT( MDNO)

      IF(LWI(CNAME,0,HEDSIZ,SNAME).NE.0) THEN
         MDOPEN=-1
         RETURN
      ENDIF

      IF (FLIP .NE. 0) CALL FMHED(SNAME)

      call movcw(cname(1:8),CFNAM)
      CMDNO=MDNO
      CALL MOVW(HEDSIZ,SNAME,MDHED(1,N))
      MDOPEN=0

      RETURN
      END
