      SUBROUTINE RDGRDPRMS(CFILE,CMOD,IGRD1,IGRD2,INTER,IPROJ,IKYNUM,
     +CMKYS,CGKYS,IGLVS,NPARM,NLEVX)
C
C  SUBROUTINE RDGRDPRMS obtains the required model information from
C   the text file (DEF=modeldata).
C
C  PARAMETERS:
C
C   CFILE = Text file containing model info (I)
C   CMOD = Name of model to process (O)
C   IGRD1 = Beginning GRID file range (O)
C   IGRD2 = Ending GRID file range (O)
C   INTER = Interval between valid GRID file times (O)
C   IPROJ = GRID projection (O)
C   IKYNUM = Number of MD file keys to fill (O)
C   CMKYS = Array of MD file key names (O)
C   CGKYS = Array of GRID file parameter names (O)
C   IGLVS = Array of number of levels for each GRID file parameter (O)
C   NPARM = Number of GRID file parameters (O)
C   NLEVX = Array of levels for each GRID file parameter (O)
C
      INTEGER IGRD1,IGRD2,INTER,IPROJ,IKYNUM,IGLVS(400),NPARM,
     +NLEVX(400,400)
      CHARACTER*4 CMOD
      CHARACTER*4 CMKYS(400),CGKYS(400)
      CHARACTER*12 CFILE
C
C Open file
C
      OPEN(UNIT=9,FILE=CFILE,STATUS='OLD')
C
C Read model name
C
      READ(9,10) CMOD
  10  FORMAT(A4)
      print *,'Model = ',CMOD
C
C Read GRID file range
C
      READ(9,15) IGRD1
  15  FORMAT(I4)
      READ(9,20) IGRD2
  20  FORMAT(I4)
      print *,'GRID range = ',IGRD1,IGRD2
C
C Read GRID file valid time interval
C
      READ(9,25) INTER
  25  FORMAT(I2)
C
C Read in GRID projection
C
      READ(9,30) IPROJ
  30  FORMAT(I1)
C
C Read in number of MD keys
C
      READ(9,35) IKYNUM
  35  FORMAT(I3)
C
C Loop to read in MD key names
C
      DO 100 I=1,IKYNUM
        READ(9,40) CMKYS(I)
  40    FORMAT(A4)
 100  CONTINUE
C
C Read in number of GRID parameters
C
      READ(9,45) NPARM
  45  FORMAT(I2)
C
C Loop through GRID parameters
C
      DO 400 J=1,NPARM
C
C Read in number of levels for a give parameter
C
        READ(9,50) IGLVS(J)
  50    FORMAT(I3)
C
C Loop through level of the GRID parameter
C
        DO 300 K=1,IGLVS(J)
C
C Read in the actual GRID parameter name and level
C
          READ(9,55) CGKYS(J),NLEVX(J,K)
  55      FORMAT(A4,1X,I4)
 300    CONTINUE
 400  CONTINUE
      CLOSE(UNIT=9)
      RETURN
      END
