      SUBROUTINE SNPOLY(X,Y,YC,DY,A,COEF,NDLO,NDHI,NPTS,LIST)
C $ COMPUTE COEFFICIENTS OF LEAST-SQUARES POLYNOMIAL (HMW)
C          Y(X) = C0 + C1*X + C2*X**2 + ...
C        OF DEGREE LESS THAN OR EQUAL TO NINE (9)
C  AND COMPARES CALCULATED VALUES OF Y WITH ORIGINAL VALUES.
C * X = ARRAY OF ABSCISSA VALUES
C * Y = ARRAY OF ORDINATE VALUES
C * YC = ARRAY TO RECEIVE ESTIMATED Y-VALUES
C * DY = ARRAY TO RECEIVE YC - Y
C * A = WORK ARRAY TO HOLD POWERS OF X
C     DIMENSIONS = (10,NPTS)
C * COEF = ARRAY TO RECEIVE COEFFICIENTS
C     DIMENSIONS = (10,NDHI)
C * NDLO = LOWEST DEGREE DESIRED
C * NDHI = HIGHEST DEGREE DESIRED
C * NPTS = NUMBER OF POINTS
C * LIST = 1 TO PRINT ESTIMATED VS. ORIGINAL Y-VALUES, 0 NOT TO PRINT
      CHARACTER*80 CBUF
      DIMENSION X(NPTS),Y(NPTS),YC(NPTS),DY(NPTS)
      DIMENSION A(10,NPTS),COEF(10,NDHI)
      REAL*8 ATA(10,10),ANV(10,10),C(10),V(10),S,SAM
      M=NPTS
      SAM=M
      NLO=NDLO+1
      NHI=NDHI+1
      DO 310 N=NLO,NHI
      ND=N-1
      DO 100 I=1,10
  100 COEF(I,ND)=0.
      IF(N.GT.NLO) GO TO 130
      DO 120 J=1,M
      A(1,J)=1.
      XX=X(J)
      DO 110 I=1,ND
  110 A(I+1,J)=A(I,J)*XX
  120 CONTINUE
      GO TO 150
  130 DO 140 J=1,M
  140 A(N,J)=A(ND,J)*X(J)
  150 DO 170 J=1,N
      DO 170 I=1,J
      S=0.
      DO 160 K=1,M
  160 S=S+A(I,K)*A(J,K)
      ATA(I,J)=S
      ATA(J,I)=S
  170 CONTINUE
      CALL SYMVRT(ATA,ANV,10,N)
      DO 190 I=1,N
      S=0.
      DO 180 J=1,M
  180 S=S+A(I,J)*Y(J)
  190 V(I)=S
      DO 210 J=1,N
      S=0.
      DO 200 I=1,N
  200 S=S+ANV(I,J)*V(I)
  210 C(J)=S
      DO 230 J=1,M
      S=0.
      DO 220 I=1,N
  220 S=S+C(I)*A(I,J)
  230 YC(J)=S
C  OBTAIN RMS AND MAXIMUM DEVIATIONS
      S=0.
      DYMX=0.
      DO 240 I=1,M
      DY(I)=YC(I)-Y(I)
      ADY=ABS(DY(I))
      IF(ADY.LE.DYMX) GO TO 240
      DYMX=ADY
      IMX=I
  240 S=S+ADY**2
      S=DSQRT(S/SAM)
C SJN CALL SDEST(' ',0)
C SJN WRITE(CBUF,'('' FOR POLYNOMIAL OF DEGREE '',I1,
C SJN* '', RMS DEVIATION = '',D12.6)') ND,S
C SJN CALL LTQ(CBUF)
      DO 250 I=1,N
      K=I-1
C SJN WRITE(CBUF,'(5X,''C'',I1,'' = '',D16.10)') K,C(I)
C SJN CALL LTQ(CBUF)
  250 COEF(I,ND)=C(I)
  260 FORMAT(' MAXIMUM DEVIATION = ',E12.6,' AT POINT ',I4)
C SJN WRITE(CBUF,260) DY(IMX),IMX
C SJN CALL LTQ(CBUF)
  270 FORMAT('  WHERE X = ',E12.6,', Y = ',E12.6,', YC = ',E12.6)
C SJN WRITE(CBUF,270) X(IMX),Y(IMX),YC(IMX)
C SJN CALL LTQ(CBUF)
      IF(LIST.EQ.0) GO TO 310
  280 FORMAT(4X,'I',10X,'X(I)',10X,'Y(I)',9X,'YC(I)',9X,'DY(I)')
C SJN WRITE(CBUF,280)
C SJN CALL LTQ(CBUF)
  290 FORMAT(1X,I4,4E14.6)
      DO 300 I=1,M
C SJN WRITE(CBUF,290) I,X(I),Y(I),YC(I),DY(I)
C SJN CALL LTQ(CBUF)
  300 CONTINUE
  310 CONTINUE
      RETURN
      END
