c 13 Nov change WREF to correct values
      SUBROUTINE TAUGIM(T,W,O,THETA,ISAT,KAN,TAU)
C $ GOES/I-M TAU via McMillin-Fleming-Woolf-Eyre regresn model (HMW)
C * Input temperatures ('T'), water-vapor mixing ratios ('W'),
C *      and ozone mixing ratios ('O') must be at the 'STANDARD'
C *      40 levels used for radiative-transfer calculations.
C * If ozone profile is not available, pass a zero-filled array.  This
C        will cause the reference profile to be used.
C * Units -- T: degrees Kelvin; W: grams/kilogram; O: ppm by volume.
C * Logical unit number 15 is used for the coefficient file.
C      THETA = local (satellite) zenith angle in degrees
C       ISAT = GOES satellite number, e.g. 8 (GOES/I)
C        KAN = channel number (1,...,25)
C               1 thru 18 are SOUNDER
C              22 thru 25 are IMAGER
C   To get Planck-function, band correction, and TSKIN coefficients,
C    plus gammas, deltas, epsilons, and 'use' flags,
C        user *MUST* call PFCGIM!
C * Total transmittance is returned via the formal parameter TAU.
C * Separate DRY/WET/OZO transmittances are returned via COMMON.
C
      CHARACTER*8 CFILE
      LOGICAL OLDATM,OLDANG
      PARAMETER (NC=3,NK=25,NL=40,NLM1=NL-1,NT=2,NV=20,NX=9,NXP1=NX+1)
      PARAMETER (LENC=NXP1*NL*NC)
      COMMON/REFATM/PREF(NL),TREF(NL),WREF(NL),OREF(NL)
      COMMON/TAUDWO/TAUD(NL),TAUW(NL),TAUO(NL)
      DIMENSION T(NL),W(NL),O(NL),TAU(NL),TL(NL),WL(NL),OL(NL)
      DIMENSION DELO(NL),DELT(NL),DELW(NL)
      DIMENSION SUMO(NL),SUMS(NL),SUMT(NL),SUMW(NL)
      DIMENSION CBUF(LENC),DP(NL),PRSQ(NL),XX(NX,NL,NC)
      DIMENSION COEF(NXP1,NL,NC,NK),TAUC(NL,NC),SQP(NC)
      DIMENSION WDEP(NL),SQW(NL),ODEP(NL),SQO(NL),SQD(NL),SQDEP(NL,NC)
      EQUIVALENCE (SQD(1),SQDEP(1,1)),(TAUD(1),TAUC(1,1))
      EQUIVALENCE (SQW(1),SQDEP(1,2)),(TAUW(1),TAUC(1,2))
      EQUIVALENCE (SQO(1),SQDEP(1,3)),(TAUO(1),TAUC(1,3))
      DATA TL/NL*0./,WL/NL*0./,OL/NL*0./,INIT/0/
      DATA SQD/NL*1./,TRAP/-999.99/,IUC/15/
      DATA CFILE/'GOESRTCX'/
      SECANT(Z) = 1./COS(0.0174533*Z)
C
      IF(KAN.GT.18.AND.KAN.LT.22) THEN
         CALL SDEST('TAUGIM -- INVALID CHANNEL NUMBER ',KAN)
         CALL MCABORT(KAN)
      ENDIF
      IF(INIT.EQ.ISAT) GO TO 130
      ISTAT = LWOPN(CFILE,IUC,LENC)
      NSAT=ISAT-7
      IREC=(NSAT-1)*NK
      DO 110 L=1,NK
      IREC=IREC+1
      ISTAT =LWREAD(IUC,IREC,COEF(1,1,1,L))
  110 CONTINUE
      ISTAT = LWCLS(IUC)
      PRSQ(1)=PREF(1)**2
      DP(1)=PREF(1)
      DO 120 J=1,NLM1
      PRSQ(J+1)=PREF(J+1)**2
  120 DP(J+1)=PREF(J+1)-PREF(J)
      THETL=TRAP
      INIT=ISAT
C
  130 DT=0.
      DW=0.
      DO=0.
      IF(O(1).NE.0.) GO TO 150
      DO 140 J=1,NL
  140 O(J)=OREF(J)
  150 DO 160 J=1,NL
      DT=DT+T(J)-TL(J)
      TL(J)=T(J)
      DW=DW+W(J)-WL(J)
      WL(J)=W(J)
      DO=DO+O(J)-OL(J)
  160 OL(J)=O(J)
      DTWO=DT+DW+DO
      OLDATM=DTWO.EQ.0.
      IF(OLDATM) GO TO 180
      ST=0.
      SS=0.
      SW=0.
      SO=0.
      DO 170 J=1,NL
      DELT(J)=T(J)-TREF(J)
      DELW(J)=W(J)-WREF(J)
      DELO(J)=O(J)-OREF(J)
      ODEP(J)=DP(J)*O(J)
      WDEP(J)=DP(J)*W(J)
      IF(J.GT.1) THEN
         DELT(J)=0.5*(DELT(J)+T(J-1)-TREF(J-1))
         DELW(J)=0.5*(DELW(J)+W(J-1)-WREF(J-1))
         DELO(J)=0.5*(DELO(J)+O(J-1)-OREF(J-1))
         ODEP(J)=DP(J)*0.5*(O(J)+O(J-1))
         IF(J.GT.NV) THEN
            WDEP(J)=DP(J)*0.5*(W(J)+W(J-1))
         ELSE
            WDEP(J)=WDEP(J-1)+DP(J)*0.5*(W(J)+W(J-1))
         ENDIF
      ENDIF
      IF (ODEP(J).LT.0)THEN
      KAN=99
      RETURN
      ENDIF
      SQO(J)=SQRT(ODEP(J))
      SQW(J)=SQRT(WDEP(J))
      DTDP=DELT(J)*DP(J)
      ST=ST+DTDP
      SUMT(J)=ST/PREF(J)
      SS=SS+DTDP*PREF(J)
      SUMS(J)=2.*SS/PRSQ(J)
      DWDP=DELW(J)*DP(J)
      SW=SW+DWDP*PREF(J)
      SUMW(J)=2.*SW/PRSQ(J)
      DODP=DELO(J)*DP(J)
      SO=SO+DODP*PREF(J)
      SUMO(J)=2.*SO/PRSQ(J)
  170 CONTINUE
  180 OLDANG=THETA.EQ.THETL
      IF(.NOT.OLDANG) THEN
         IF(THETA.EQ.0.) THEN
            PATH=1.
            SQRTP=1.
         ELSE
            PATH=SECANT(THETA)
            SQRTP=SQRT(PATH)
         ENDIF
         PATHM1=PATH-1.
         SQP(1)=1.
         SQP(2)=SQRTP
         SQP(3)=SQRTP
         THETL=THETA
      ENDIF
      IF(OLDATM.AND.OLDANG) GO TO 200
      DO 190 J=1,NL
      DT=DELT(J)
      SS=SUMS(J)
      ST=SUMT(J)
C * DRY
      XX(1,J,1)=DT*PATH
      XX(2,J,1)=DT*DT*PATH
      XX(3,J,1)=ST*PATH
      XX(4,J,1)=SS*PATH
      XX(5,J,1)=PATHM1
      XX(6,J,1)=PATHM1*PATHM1
      XX(7,J,1)=ST*PATHM1
      XX(8,J,1)=SS*PATHM1
      XX(9,J,1)=DT*PATHM1
C * WET
      SQPW=SQRTP*SQW(J)
      DW=DELW(J)
      SW=SUMW(J)
      XX(1,J,2)=DT
      XX(2,J,2)=SS
      XX(3,J,2)=DW
      XX(4,J,2)=SW
      XX(5,J,2)=DT*SQPW
      XX(6,J,2)=DT*DT*SQPW
      XX(7,J,2)=DW*SQPW
      XX(8,J,2)=DW*DW*SQPW
      XX(9,J,2)=DW*DT*SQPW
C * OZO
      SQPO=SQRTP*SQO(J)
      DO=DELO(J)
      SO=SUMO(J)
      XX(1,J,3)=DT
      XX(2,J,3)=SS
      XX(3,J,3)=DO
      XX(4,J,3)=SO
      XX(5,J,3)=DT*SQPO
      XX(6,J,3)=DT*DT*SQPO
      XX(7,J,3)=DO*SQPO
      XX(8,J,3)=DO*DO*SQPO
      XX(9,J,3)=DO*DT*SQPO
  190 CONTINUE
  200 DO 210 K=1,NC
      DO 210 J=1,NL
  210 TAUC(J,K)=1.0
      L=KAN
      DO 240 K=1,NC
      TAUL=1.
      DO 230 J=1,NL
      IF(TAUL.EQ.0.) GO TO 230
      YY=COEF(NXP1,J,K,L)
      IF(YY.EQ.TRAP) THEN
         TAUL=0.
         GO TO 230
      ENDIF
      DO 220 I=1,NX
  220 YY=YY+COEF(I,J,K,L)*XX(I,J,K)
      YY=AMIN1(YY,0.)
      TAUY=TAUL*EXP(YY*SQDEP(J,K)*SQP(K))
      TAUL=TAUY
  230 TAUC(J,K)=TAUL
  240 CONTINUE
      DO 250 J=1,NL
  250 TAU(J)=TAUD(J)*TAUW(J)*TAUO(J)
      RETURN
      END
      BLOCK DATA
C * TRANSMITTANCE-MODEL REFERENCE = U.S. STANDARD ATMOSPHERE, 1976
      PARAMETER (NL=40)
      COMMON/REFATM/PREF(NL),TREF(NL),WREF(NL),OREF(NL)
      DATA PREF/ .1,.2,.5,1.,1.5,2.,3.,4.,5.,7.,10.,15.,20.,25.,30.,
     + 50.,60.,70.,85.,100.,115.,135.,150.,200.,250.,300.,350.,400.,
     + 430.,475.,500.,570.,620.,670.,700.,780.,850.,920.,950.,1000./
      DATA TREF/
     +  231.70, 245.22, 263.35, 270.63, 264.07, 257.93, 249.51, 243.65,
     +  239.24, 232.64, 228.07, 225.00, 223.13, 221.72, 220.54, 217.28,
     +  216.70, 216.70, 216.70, 216.70, 216.70, 216.70, 216.70, 216.72,
     +  220.85, 228.58, 235.38, 241.45, 244.81, 249.48, 251.95, 258.32,
     +  262.48, 266.40, 268.61, 274.21, 278.74, 282.97, 284.71, 287.50/
      DATA WREF/
     +   0.003,  0.003,  0.003,  0.003,  0.003,  0.003,  0.003,  0.003,
     +   0.003,  0.003,  0.003,  0.003,  0.003,  0.003,  0.003,  0.003,
     +   0.003,  0.003,  0.003,  0.003,  0.003,  0.004,  0.005,  0.014,
     +   0.036,  0.089,  0.212,  0.331,  0.427,  0.588,  0.699,  1.059,
     +   1.368,  1.752,  1.969,  2.741,  3.366,  3.976,  4.255,  4.701/
      DATA OREF/
     + 0.65318,1.04797,2.13548,3.82386,5.26768,6.11313,7.35964,7.75004,
     + 7.82119,7.56126,6.92006,6.10266,5.55513,5.15298,4.59906,2.86792,
     + 2.29259,1.80627,1.28988,0.93973,0.72277,0.54848,0.46009,0.29116,
     + 0.16277,0.09861,0.06369,0.05193,0.04718,0.04097,0.03966,0.03614,
     + 0.03384,0.03342,0.03319,0.03249,0.03070,0.02878,0.02805,0.02689/
      END
