      SUBROUTINE TSNIO(IOP,IFL,IR,IC,NR,NC,IA)          
C $ SUBROUTINE TSNIO(IOP,IFL,IR,IC,NR,NC,IA)        (BTR)  
C $ READ/WRITE POLAR ORBITER FILES (IMAGING)  
C $ IOP = 1   READ HEADER 
C $       3   WRITE HEADER             
C $       0   READ DATA            
C $       2   WRITE DATA                          
C $      -1   CLOSE FILE                             
C $ IFL = (I) INPUT  LOGICAL FILE NO                 
C $ IR = (I) INPUT  INITIAL ROW                
C $ IC = (I) INPUT  INITIAL ELEMENT IN ROW      
C $ NR = (I) INPUT  NO OF ROWS TO PROCESS    
C $ NC = (I) INPUT  NO. OF ELEMENTS PER ROW     
C $ IA = (I) OUTPUT BUFFER (FILLED SEQUENTIALLY)    
C $$ TSNIO = VAS             
      CHARACTER*8 FILE,TFILE  
      DIMENSION IA(*),IBUF(112)    
      COMMON/IDENT/IYMD,IHMS,NROWM,ISAT    
      DATA LPTR/-1/,MAXROW/100/,MAXCOL/56/,MAXFL/31/,NSPF/50/,LRECP/-1/
      DATA FILE/'TOVORB  '/,MREC/1551/,MZFF/Z'FF'/,MAXPTR/20/ 
      DATA TFILE/'MSUORB  '/ 
      DATA IU/22/,LEN/112/   
      IPTR=LUC(80)      
      IF(IPTR.EQ.0) GO TO 700    
      IF(IABS(IPTR).GT.MAXPTR) GO TO 700   
      IF (IPTR.GT.0)GO TO 5    
C     NEGATIVE POINTER INDICATES AN MSU ORBIT FILE    
      IPTR=-IPTR
      FILE=TFILE    
 5    IF(IPTR.EQ.LPTR) GO TO 10 
      IPTX=IPTR+100  
      WRITE(FILE(6:8),'(I3)') IPTX
      FILE(6:6)='B'       
      ISTAT = LWOPN(FILE,IU,LEN)   
      LPTR=IPTR    
   10 CONTINUE     
      IF(IOP.LT.0) GO TO 300    
      IF(MOD(IOP,2).EQ.0) GO TO 100 
C * HEADER RECORD    
      LREC=1    
      LRECP=LREC  
      IF(IOP.EQ.1) GO TO 20    
      IF(IOP.NE.3) GO TO 350       
      ISTAT = LWRITE(IU,LREC,IA) 
      GO TO 200  
   20 CONTINUE   
      ISTAT = LWREAD(IU,LREC,IA)  
      NROWM=IA(4)     
      ISAT=IA(5)  
      IYMD=IA(1)  
      IHMS=IA(2)   
      GO TO 200  
  100 CONTINUE   
C * DATA        
      IF(IOP.GT.2) GO TO 350  
      KEY=IOP/2+1                   
C * KEY = 1 FOR INPUT, 2 FOR OUTPUT  
      IF (IFL.GT.MAXFL.OR.IFL.LT.1)GO TO 400  
      IF (IR.LT.1.OR.IR.GT.MAXROW)GO TO 500 
      IF (IC.LT.1.OR.IC.GT.MAXCOL)GO TO 500 
      IRR=IR  
      LR=IR+NR-1  
      IF (LR.GT.MAXROW)GO TO 500 
      LC=IC+NC-1 
      IF (LC.GT.MAXCOL)GO TO 500  
      N=1  
      NN=NSPF*(IFL-1)+1   
  110 IB=MOD(IRR-1,2)*MAXCOL  
      ISEC=NN+(IRR-1)/2+1    
      LREC=ISEC      
      IF(LREC.GT.MREC) GO TO 600  
      IF(LREC.EQ.LRECP) GO TO 120   
      ISTAT = LWREAD(IU,LREC,IBUF)  
      LRECP=LREC  
  120 CONTINUE    
      GO TO (125,135), KEY  
  125 DO 130 I=IC,LC   
      IA(N)=IBUF(IB+I)   
  130 N=N+1     
      GO TO 150   
  135 DO 140 I=IC,LC 
      IBUF(IB+I)=IA(N)    
  140 N=N+1   
      IF(IB.EQ.0.AND.IRR.NE.LR) GO TO 160  
      ISTAT = LWRITE(IU,LREC,IBUF)  
  150 IF(IRR.EQ.LR) GO TO 200
  160 IRR=IRR+1   
      GO TO 110 
  200 RETURN  
  300 ISTAT = LWCLS(IU) 
      LPTR=-1  
      RETURN  
  350 CALL SDEST(' *** TSNIO ... BAD OPERATION-CODE ',IOP)  
      GO TO 800   
  400 CALL SDEST(' *** TSNIO ... BAD FILE NUMBER ',IFL)  
      GO TO 800  
  500 CONTINUE  
      CALL SDEST(' *** TSNIO ... BAD INDEXING ***  ',0)  
      CALL SDEST('      IR = ',IR)  
      CALL SDEST('      IC = ',IC) 
      CALL SDEST('      NR = ',NR) 
      CALL SDEST('      NC = ',NC)
      GO TO 800     
  600 CALL SDEST(' *** TSNIO ... RECORD NO. TOO LARGE ',LREC)  
      GO TO 800    
  700 CALL SDEST(' INVALID POINTER ',IPTR) 
  800 CALL MCABORT(MZFF) 
C  800 CALL ABORT 
      RETURN  
      END  
