      SUBROUTINE VASGES(MDNO,FLAT,FLON)
C $ SUBROUTINE VASGES(MDNO,FLAT,FLON)            (CMH)
C $ ENTERS AND EXTRACTS GUESS VECTORS OF TEMP,DEWPOINT IN VASGSS FILE
C $   GUESS VALUES ARE MOVED THROUGH COMMON /GUESS/ AND /SURF/
C $ MDNO = (I) INPUT   VSGSS FILE NUMBER
C $ FLAT = (R) INPUT   LATITUDE
C $ FLON = (R) INPUT  LONGITUDE
C $$ VASGES = VAS
      COMMON /GUESR/TEMP(24),TDEW(19)
      COMMON /GUESS/TEM(15),TDW(6)
      COMMON /SURF/ IZ10,ITSFC,IDSFC,IPSTA,IEL,LSTA
      CHARACTER*8 ITYPE
C     ESTABLISH INPUT VECTORS FOR MDKEYS
      CHARACTER*4 RLIST(3),CLIST,OLIST(44)
      CHARACTER*12 CFF
      INTEGER OSCR(44),OPTS(44),OVAL(44)
      INTEGER*4 OV2(44),OV3(44),OV4(44),LR(15)
      INTEGER CSCR,CPTS,CVAL
      INTEGER RSCR(3),RPTS(3),RVAL(3)
C     MDKEYS EXPECTS ALL INTEGER ARGUMENTS
      INTEGER IRLIST(3),ICLIST,IOLIST(44)
      EQUIVALENCE (IRLIST(1),RLIST(1)),(ICLIST,CLIST)
      EQUIVALENCE (IOLIST(1),OLIST(1))
      COMMON /GDATE/RVAL
      DATA MISS/Z'80808080'/
      DATA ITYPE/'UNPACKED'/
      DATA RLIST/'DAY ','TIME','LAT '/,CLIST/'LON '/
      DATA OLIST/
     * 'T100','T95 ','T90 ','T85 ','T80 ','T75 ','T70 ','T65 '
     *,'T60 ','T55 ','T50 ','T45 ','T40 ','T35 ','T30 ','T25 ','T20 '
     *,'T15 ','T10 ','T07 ','T05 ','T03 ','T02 ','T01 '
     *,'D100','D95 ','D90 ','D85 ','D80 ','D75 ','D70 ','D65 ','D60 '
     *,'D55 ','D50 ','D45 ','D40 ','D35 ','D30 ','D25 ','D20 '
     *,'D15 ','D10 ','Z100'/
      DATA LR/1,4,7,11,13,15,16,17,18,19,20,21,22,23,24/
      DATA INIT/0/,NPAR/44/,NROW/3/,NCOL/1/
      IF (INIT.EQ.1)GO TO 10
C     FOLLOWING ALLOWS ONLY ONE MESSAGE FOR BAD MD FILE...
      IF (IOK.LT.0)RETURN
C     READ IN 2 ROW HEADERS TO ESTABLISH NORTH LAT AND INC
C     SET UP WITH MDKEYS
      IVAL=1
      IOK=MDKEYS(MDNO,NROW,IRLIST,RSCR,RSCR,RPTS)
      IF (IOK.LT.0)GO TO 90
      DO 1 N=1,2
      IOK=MDI(MDNO,N,0,NROW,RPTS,RVAL)
      IF (IOK.LT.0)GO TO 95
      IF (N.EQ.1)LAN=RVAL(3)
      FLAN=LAN*.0001
    1 CONTINUE
      LAINC=LAN-RVAL(3)
      FLAINC=LAINC*.0001
C     DO SAME FOR COL HEADERS FOR LONGITUDE
      IVAL=2
      IOK=MDKEYS(MDNO,NCOL,ICLIST,CSCR,CSCR,CPTS)
      IF (IOK.LT.0)GO TO 90
      DO 2 N=1,2
      IOK=MDI(MDNO,0,N,NCOL,CPTS,CVAL)
      IF (IOK.LT.0)GO TO 95
      IF (N.EQ.1)LOW=CVAL
      FLOW=LOW*.0001
    2 CONTINUE
      LOINC=LOW-CVAL
      FLOINC=ABS(LOINC*.0001)
C     CHECK FOR HIGHLY UNLIKELY STEP OVER DATELINE OR GREENWICH
      IF (FLOINC.GT.180.)FLOINC=ABS(360.-FLOINC)
C     SET UP KEYS FOR GUESS VALUES
      IVAL=3
      IOK=MDKEYS(MDNO,NPAR,IOLIST,OSCR,OSCR,OPTS)
      IF (IOK.LT.0)GO TO 90
      INIT=1
   10 CONTINUE
C     CORRECT FOR POSSIBLE ROUNDOFF
C     CALCULATE ROW AND COLUMN
      SJ=(FLAN-FLAT)/FLAINC+1.001
C  ATTEMPTING TO DEAL WITH DATELINE AMBIGUITY
      IF(FLOW.LT.0.0.AND.FLOW.LT.FLON)FLON=FLON-360.
      SI=(FLOW-FLON)/FLOINC+1.001
      I=SI
      IF (I.LE.0)GO TO 95
      DELI=SI-I
      J=SJ
      IF (J.LE.0)GO TO 95
      DELJ=SJ-J
      IOK=MDI(MDNO,J,I,NPAR,OPTS,OVAL)
      IF (IOK.LT.0)GO TO 95
      IOK=MDI(MDNO,J,I+1,NPAR,OPTS,OV2)
      IF (IOK.LT.0)DELI=0.
      IOK=MDI(MDNO,J+1,I,NPAR,OPTS,OV3)
      IF (IOK.LT.0)DELJ=0.
      IOK=MDI(MDNO,J+1,I+1,NPAR,OPTS,OV4)
C      PICK OUT PARAMETERS
      DO 30 I=1,24
      VALUE=.01*TERP(OVAL(I),OV2(I),OV3(I),OV4(I),DELI,DELJ)
      IF (VALUE.LT.150.OR.VALUE.GT.350.)GO TO 25
      TEMP(I)=VALUE
      GO TO 30
C       ALLOW BAD STRATOSPHERE, BUT USE CLIMATE VALUE
   25 TEMP(I)=999.
   30 CONTINUE
C     INSIST ON 100 MB TEMPERATURE FOR LATER EXTRAPOLATION
      IF (TEMP(19).EQ.999.)GO TO 95
C     INTERPOLATE DEWPOINTS
      DO 40 I=1,19
      M=I+24
      VALUE=.01*TERP(OVAL(M),OV2(M),OV3(M),OV4(M),DELI,DELJ)
      IF (VALUE.LT.150.OR.VALUE.GT.350.)GO TO 35
      TDEW(I)=VALUE
      GO TO 40
   35 TDEW(I)=999.
   40 CONTINUE
C     INSIST ON 1000 MB TEMP AND DEWPOINT
      IF (TDEW(1).EQ.999..OR.TEMP(1).EQ.999.)GO TO 95
C     FILL MSL PARAMETERS IN CASE WE DON'T HAVE SFC ANALYSES
      DD=TEMP(1)-TDEW(1)
      IZ10=104
      IF (OVAL(44).EQ.MISS)GO TO 56
C     GUARD AGAINST EVENT WHERE 1000 HEIGHTS ARE MISSING
      IZ10=TERP(OVAL(44),OV2(44),OV3(44),OV4(44),DELI,DELJ)
   56 TMSL=TEMP(1)+.0065*FLOAT(IZ10)
      ITSFC=TMSL*100.
      IDSFC=ITSFC-DD*100.
C     FILL UP SMALL ARRAYS
      DO 70 K=1,15
      TEM(K)=TEMP(LR(K))
   70 CONTINUE
      DO 75 K=1,6
      TDW(K)=TDEW(LR(K))
   75 CONTINUE
   80 RETURN
   90 TEM(1)=-999.
      CALL SDEST(' VASGES HAVING A PROBLEM WITH MDKEYS..IVAL IS ',IVAL)
      RETURN
   95 TEM(1)=-999.
      RETURN
      END
C      FUNCTION TERP(O1,O2,O3,O4,DELI,DELJ)
C $ FUNCTION TERP(O1,O2,O3,O4,DELI,DELJ)               (CMH)
C $ INTERPOLATE A VALUE IN TWO DIMENSIONS
C $ INPUT:  O1 = (I) TOP LEFT VALUE
C $         O2 = (I) TOP RIGHT VALUE
C $         O3 = (I) BOTTOM LEFT VALUE
C $         O4 = (I) BOTTOM RIGHT VALUE
C $         DELI = (R) HORIZONTAL INCREMENT
C $         DELJ = (R) VERTICAL INCREMENT
C $ FUNCTION VALUE IS THE INTERPOLATED VALUE
C $$ TERP = VAS,MV,COMPUTATION
C      INTEGER*4 O1,O2,O3,O4
C      TL=FLOAT(O1)
C      TR=FLOAT(O2)
C      BL=FLOAT(O3)
C      BR=FLOAT(O4)
C      TOP=TL+DELI*(TR-TL)
C      BOT=BL+DELI*(BR-BL)
C      TERP=TOP+DELJ*(BOT-TOP)
C      RETURN
C      END
