/* giminit gets the names of the output area file (area0) and the input area
   files (area1 to area5).  The files are opened with gcmcidas routine
   'opnara'.  The input area directories are saved in structure 'gf' as dir.
   Area1 directory is copied into area 0 directory, changes to this directory
   will be made in later routines.  A directory definition structure is 
   overlaid on each file directory using pointers in array dirp. */

#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include "toks.h"
#include "gcmcidas.h"
#include "gimfiles.h"
#include "direct.h"
#include "bandparams.h"
extern Direct_ptr dirp[MAXCMDOPT];	/* uses direct.h */
#define PARMS 0666
extern char **varg;
extern int bug;

int giminit (void)
{
 char cerror[100];
 int i;
 int  start_byte, lpos, n_read, n_bytes;

 for (i=0; i<MAXCMDOPT; i++) {dirp[i] = NULL;}	/* initialize to NULL (missing) */
 /* Read in files from command line. First is area0, the output area. */
 for (i=0; i<MAXCMDOPT; i++)
  {gf[i].file = cpp(i+1,"\0");
   if (strlen(gf[i].file) == 0) break;
   num_in_files++;	/* global, defined in gimfiles.h */
  }

 if (num_in_files < 0) {printf("no files specified\n"); return -1;}
 if (bug > 0) printf("output file: %s\n", gf[0].file);
 if (num_in_files < 1) {printf("no input files specified\n"); return -1;}
 if (num_in_files == 1)
  {printf("only one input file specified, why are you combining one area?\n");
   return -1;}
 if (bug > 0)
   for (i=1; i<=num_in_files; i++)
    {(void)printf("input  file: %s\n", gf[i].file);}
 dirp[0] = (void*)(gf[0].dir);		/* structure of directory elements */

 gf[0].fileno = opnara (gf[0].file, 'W');
 if (gf[0].fileno < 0) {(void)printf("opnara failed area0\n"); return -1;}

 for (i=1; i<=num_in_files; i++)
  {gf[i].fileno = opnara (gf[i].file, 'R');
   if (gf[i].fileno < 0) {(void)printf("opnara failed area%1d\n",i); return -1;}

   /* Read in area directory */
   errno = 0;
   start_byte = 0;
   if (lpos = lseek(gf[i].fileno, start_byte, 0) < 0)
    {sprintf(cerror,"%s: main: lseek error l6 errno= %d fdw: %d %d %d\n",
       varg[0],errno,gf[i].fileno,start_byte,lpos);
     perror(cerror); (void)printf(cerror); return -1;}
   n_bytes = 256;
   n_read = read (gf[i].fileno, gf[i].dir, n_bytes ) ;
   if (n_read != n_bytes && errno != 0)
    {sprintf(cerror,"%s: giminit: read error r3 errno= %d fileno: %d "
       " %d %d\n",varg[0],errno,gf[i].fileno,n_read,n_bytes);
     (void)printf(cerror); perror(cerror); }

   dirp[i] = (void *)gf[i].dir;		/* structure of directory elements */
  }	/* end of for loop on i over input files */

 for (i=0; i<64; i++) { gf[0].dir[i] = gf[1].dir[i]; }

 return 0;
}
