#include <stdio.h>
#include <errno.h>
#include <unistd.h>	/* read, write, lseek, close */
#include "aracom.h"
#include "direct.h"

extern char **varg;

/*  STATUS = WRTARA (area,line,iarray)
    WRTARA - Read line from area returning specified subset of line
    Input:
      AREA = (I) area number
      LINE = (I) line to read
    OUTPUT:
      IARRAY = (I) array to hold returned data, includes prefix */

int  wrtara (int fd, int line, int  *buf)
{
 int i;  /* index */
 int  loc;	/* location of first byte */
 int  len;	/* length of prefix */
 int cur_area = -1;
 int status;
 char cerror[120];

 /*printf("in wrtara fd %2d line %3d \n", fd, line);*/ /*DEBUG*/
 for (i=0; i<=new_area; i++)
  {if(aracom[i].fd == fd) {cur_area=i; break;}}
 if(cur_area == -1)
  {printf ("file %d not opened \n",fd); return -1;}
 directptr = (void *)aracom[cur_area].dir;

 loc = (aracom[cur_area].line_len + aracom[cur_area].pref_len) * line +
    directptr->data_loc;
 len = aracom[cur_area].line_len + aracom[cur_area].pref_len;
 /*printf("loc %8d len %6d\n", loc, len);*/ /* DEBUG */
 errno = 0;
 i = lseek(fd,loc,0);
 if (i < 0)
  {sprintf(cerror,"%s: wrtara: lseek error l1 errno= %d fdi: %d %d %d\n",
     varg[0],errno,fd,loc,i);
   perror(cerror); printf(cerror); return -1;}
 errno = 0;
 i = write (fd, buf, len);
 if (i != len && errno != 0)
  {sprintf(cerror,"%s: wrtara: write error r1 errno= %d fd: %d "
     " %d %d %d\n",varg[0],errno,fd,len,i,loc);
   printf(cerror); perror(cerror); return -1;}

 /* DEBUG */
 /*printf("%d\n", cur_area);*/
 /*printf("%08x %08x wrtara\n", aracom[cur_area].cin, aracom[cur_area].cout);*/
 /* DEBUG */

 return 0;
}
